  MEMBER


  INCLUDE('LOCEQUA.CLW')
  INCLUDE('LOCRICH.INC')
  INCLUDE('ERRORS.CLW')
  INCLUDE('KEYCODES.CLW')
  INCLUDE('PRNPROP.CLW')

  INCLUDE('ABRESIZE.INC') ! -   Resize ABC Class
  INCLUDE('RESDEF.CLW')   ! -   Resize STD Class

  MAP
    MODULE('API_FUNCTION_CALL')   !Api Function Call for Rich Edit Control
      ! -- Create Rich Edit Control -----------------------------------------------------------------------------------------
      LoadLibrary(*LPCSTR), HINSTANCE, PASCAL, RAW, NAME('LoadLibraryA')
      CreateWindowEx(DWORD, *LPCSTR, *LPCSTR, DWORD, SIGNED, SIGNED, SIGNED, SIGNED, HWND, HMENU, HINSTANCE, LPVOID), HWND, PASCAL, RAW, NAME('CreateWindowExA')
      ShowWindow(HWND, SIGNED), BOOL, PASCAL
      IsWindowVisible(HWND), BOOL, PASCAL
      ! -- Miscellaneous Procedures -----------------------------------------------------------------------------------------
      SendMessage(HWND, UNSIGNED, WPARAM, LPARAM), LRESULT, PASCAL, NAME('SendMessageA')
      MoveWindow(HWND, SIGNED, SIGNED, SIGNED, SIGNED, BOOL), PASCAL
      GetWindowRect(HWND, *_RECT), BOOL, PASCAL, RAW
      GetClientRect(HWND, *_RECT), BOOL, PASCAL, RAW
      SetFocus(HWND), HWND, PASCAL
      GetFocus(), HWND, PASCAL
      ! -- Printer and Format Procedures ------------------------------------------------------------------------------------
      GetDeviceCaps(HDC, SIGNED), SIGNED, PASCAL
      SetMapMode(HDC, SIGNED), SIGNED, PASCAL
      PrintDlg(*_PRINTDLG), BOOL, PASCAL, RAW, NAME('PrintDlgA')
      PageSetupDlg(*_PAGESETUPDLG), BOOL, PASCAL, RAW, NAME('PageSetupDlgA')
      CreateDC(*LPCSTR, *LPCSTR , *LPCSTR ,*LONG ), HDC, PASCAL, RAW, NAME('CreateDCA')
      DeleteDC(HDC), BOOL, PASCAL
      GetDC(HWND), HDC, PASCAL
      ReleaseDC(HWND, HDC), SIGNED, PASCAL
      StartDoc(HDC, *DOCINFO), SIGNED, PASCAL, RAW, NAME('StartDocA')
      EndDoc(HDC), SIGNED, PASCAL
      StartPage(HDC), SIGNED, PASCAL
      EndPage(HDC), SIGNED, PASCAL
      ! -- Create Font List -------------------------------------------------------------------------------------------------
      EnumFontFamiliesEx(HDC, *_LOGFONT, PVOID, LPARAM, DWORD), SIGNED, PASCAL, RAW, NAME('EnumFontFamiliesExA')
      ! -- Call Window Message Procedure ------------------------------------------------------------------------------------
      GetWindowLong(HWND, SIGNED), LONG, PASCAL, NAME('GetWindowLongA')
      SetWindowLong(HWND, SIGNED, LONG), LONG, PASCAL, NAME('SetWindowLongA')
      CallWindowProc(PVOID, HWND, UNSIGNED, WPARAM, LPARAM), LRESULT, PASCAL, NAME('CallWindowProcA')
    END
    PopToolbox(STRING ProcAddress, STRING ToolBoxType)
    StreamLoad(ULONG dwCookie, ULONG pbBuff, ULONG cb, *ULONG pcb), ULONG, PASCAL, PRIVATE
    StreamSave(ULONG dwCookie, ULONG pbBuff, ULONG cb, *ULONG pcb), ULONG, PASCAL, PRIVATE
    EnumFontFamExProc(*_LOGFONT LogFont, *_TEXTMETRIC TextMetric, SIGNED FontType, LONG lParam), SIGNED, PRIVATE
    WindowsMessage(HWND, UNSIGNED, WPARAM, LPARAM), LRESULT, PASCAL
  END

FontQueue           &_FONTQUEUE         !   Callback for read font-names

MsgQueue            QUEUE               !   Callback for read Window Messages
WndHwnd               LONG
WndProc               LONG
WndClass              &LocRichEditClass
                    END

StreamPointer       LONG                !   Callback for load & save document
StreamLength        LONG                !   |

! ---------------------------------------------------------------------------------------------------------------------------
! STREAMIN AND STREAMOUT FORMATS
! ---------------------------------------------------------------------------------------------------------------------------

! Stream File reads max 10 Kb at a time from the dos file

RTFStreamFileName   CSTRING(256)
RTFStreamExt        CSTRING(10)
RTFStreamFile       FILE,DRIVER('DOS'),NAME(RTFStreamFileName),CREATE
StreamRecord          RECORD
Stream                  CSTRING(10241)
                      END
                    END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| TextBox:     Create a Rich Edit Control over the Textbox parameter
!| Tabulator:   If TRUE there will be created a tabulator bar over the Rich Edit Control
!| InitString:  The value in the InitSting will be inserted as text in the Rich Edit Control at creation time
!|
LocRichEditClass.Init               PROCEDURE(LONG TextBox, BYTE Tabulator=TRUE, BYTE Statusbar=TRUE, BYTE WordWrap=TRUE, BYTE NormalRTT=TRUE)

ControlHandle   LONG(0)
lpLibFileName   CSTRING('RICHED20.DLL')  ! Version 2.0/3.0 = RICHED20.DLL
lpClassName     CSTRING('RichEdit20A')   ! Version 2.0/3.0 = RichEdit20A
lpWindowName    CSTRING(256)
dwExStyle       ULONG
dwStyle         ULONG
WM              LONG
fName           CSTRING(32)
fSize           LONG
fColor          LONG
fBack           LONG
fStyle          LONG
CtrlEquate      LONG
CtrlNumber      LONG
GrandParent     LONG
ControlDC       LONG
LogX            LONG
SavedWndProc    LONG

IconWindow      WINDOW  ! Dummy window to hold icons and bitmaps (linking into project)
                  ! --- Icon for dialogs ---------------------
                  IMAGE('RichEdit.ico');
                  ! --- Bitmaps for tabulator and indent -----
                  IMAGE('RtfIndent.bmp');           IMAGE('RtfOffset.bmp');         IMAGE('RtfTabMark.bmp')
                  ! --- Icons for check menus and buttons ----
                  IMAGE('RtfRegular.ico');          IMAGE('RtfRegular_d.ico');      IMAGE('RtfRegularDis.ico')
                  IMAGE('RtfBold.ico');             IMAGE('RtfBold_d.ico');         IMAGE('RtfBoldDis.ico')
                  IMAGE('RtfItalic.ico');           IMAGE('RtfItalic_d.ico');       IMAGE('RtfItalicDis.ico')
                  IMAGE('RtfUnderline.ico');        IMAGE('RtfUnderline_d.ico');    IMAGE('RtfUnderlineDis.ico')
                  IMAGE('RtfStrikeout.ico');        IMAGE('RtfStrikeout_d.ico');    IMAGE('RtfStrikeoutDis.ico')
                  IMAGE('RtfLeft.ico');             IMAGE('RtfLeft_d.ico');         IMAGE('RtfLeftDis.ico')
                  IMAGE('RtfCenter.ico');           IMAGE('RtfCenter_d.ico');       IMAGE('RtfCenterDis.ico')
                  IMAGE('RtfRight.ico');            IMAGE('RtfRight_d.ico');        IMAGE('RtfRightDis.ico')
                  IMAGE('RtfBullet.ico');           IMAGE('RtfBullet_d.ico');       IMAGE('RtfBulletDis.ico')
                  IMAGE('RtfSingle.ico');           IMAGE('RtfSingle_d.ico');       IMAGE('RtfSingleDis.ico')
                  IMAGE('RtfOneAndAHalf.ico');      IMAGE('RtfOneAndAHalf_d.ico');  IMAGE('RtfOneAndAHalfDis.ico')
                  IMAGE('RtfDouble.ico');           IMAGE('RtfDouble_d.ico');       IMAGE('RtfDoubleDis.ico')
                  IMAGE('RtfSubScript.ico');        IMAGE('RtfSubScript_d.ico');    IMAGE('RtfSubScriptDis.ico')
                  IMAGE('RtfSuperScript.ico');      IMAGE('RtfSuperScript_d.ico');  IMAGE('RtfSuperScriptDis.ico')
                  IMAGE('RtfUrlDetect.ico');        IMAGE('RtfUrlDetect_d.ico')
                  ! --- Icons for normal menus and buttons ---
                  IMAGE('RtfNew.ico');              IMAGE('RtfSaveAs.ico');         IMAGE('RtfPageSetup.ico')
                  IMAGE('RtfParagraph.ico');        IMAGE('RtfTabStops.ico');       IMAGE('RtfFind.ico')
                  IMAGE('RtfFindNext.ico');         IMAGE('RtfReplace.ico');        IMAGE('RtfUndo.ico')
                  IMAGE('RtfRedo.ico');             IMAGE('RtfSelectAll.ico');      IMAGE('RtfMailMerge.ico')
                  IMAGE('RtfDateTime.ico');         IMAGE('RtfRegular.ico');        IMAGE('RtfFont.ico')
                  IMAGE('RtfColor.ico');            IMAGE('RtfBackColor.ico');      IMAGE('RtfBlank.ico')
                  ! ------------------------------------------
                END
 
  CODE

  ASSERT(TextBox)
  SELF.ParentWindow       &= SYSTEM{PROP:Target}
  SELF.TextBox             = TextBox
  SELF.Setup.SystemIcon    = SYSTEM{PROP:Icon}
  SELF.Setup.WindowCaption = SELF.ParentWindow{PROP:Text}

  fName  = TextBox{PROP:FontName}
  fSize  = TextBox{PROP:FontSize}
  fColor = TextBox{PROP:FontColor}
  fBack  = TextBox{PROP:FillColor}
  fStyle = TextBox{PROP:FontStyle}

  ASSERT(LoadLibrary(lpLibFileName))

  ! -- Extended Window Style ------------------
  dwExStyle = WS_EX_CLIENTEDGE
  IF TextBox{PROP:Trn}        THEN dwExStyle += WS_EX_TRANSPARENT.
  ! -- Standard Window Style ------------------
  dwStyle = ES_WANTRETURN + ES_NOHIDESEL + WS_CHILD + WS_GROUP
  IF NOT TextBox{PROP:Single} THEN dwStyle += ES_MULTILINE.
  IF NOT TextBox{PROP:Skip}   THEN dwStyle += WS_TABSTOP.
  IF TextBox{PROP:Visible}    THEN dwStyle += WS_VISIBLE.
  IF TextBox{PROP:Disable}    THEN dwStyle += WS_DISABLED; Tabulator = FALSE.
  IF TextBox{PROP:ReadOnly}   THEN dwStyle += ES_READONLY; Tabulator = FALSE.
  IF TextBox{PROP:VScroll}    THEN dwStyle += WS_VSCROLL + ES_AUTOVSCROLL.
  IF TextBox{PROP:HScroll}    THEN dwStyle += WS_HSCROLL + ES_AUTOHSCROLL; SELF.Setup.HScroll = TRUE.
  ! -- Textbox is placed on a sheet/tab -------
  CtrlEquate = TextBox{PROP:Parent}
  GrandParent = CtrlEquate{PROP:Parent}
  IF CtrlEquate{PROP:Type} = CREATE:Tab
    LOOP CtrlNumber = CtrlEquate TO FIRSTFIELD() BY -1
      IF CtrlNumber{PROP:Type} = CREATE:Tab AND CtrlNumber{PROP:Parent} = GrandParent
        SELF.TabSheetNumber += 1
      ELSIF CtrlNumber{PROP:Type} = CREATE:Sheet AND CtrlNumber = GrandParent
        BREAK
      END
    END
  END
  ! -------------------------------------------
  HIDE(TextBox)

  SELF.RTFhwnd = CreateWindowEx(dwExStyle, lpClassName, lpWindowName, dwStyle, 0, 0, 0, 0, SELF.ParentWindow{PROP:ClientHandle}, 0, SYSTEM{PROP:AppInstance}, 0)

  ASSERT(SELF.RTFhwnd)

  ! --- Set Default Size of CharFormat ----------
  CLEAR(SELF.CharFormat)
  SELF.CharFormat.cbSize = SIZE(SELF.CharFormat)
  ! --- Set Default Size of ParaFormat ----------
  CLEAR(SELF.ParaFormat)
  SELF.ParaFormat.cbSize = SIZE(SELF.ParaFormat)
  ! --- Set Default Char Format From TextBox ----
  SELF.CharFormat.dwMask      = CFM_FACE + CFM_SIZE + CFM_COLOR + CFM_BACKCOLOR + CFM_BOLD + CFM_ITALIC + CFM_UNDERLINE + CFM_STRIKEOUT
  SELF.CharFormat.szFaceName  = fName
  SELF.CharFormat.yHeight     = fSize * 20
  SELF.CharFormat.crTextColor = fColor
  SELF.CharFormat.crBackColor = fBack
  IF BAND(fStyle, FONT:Weight) = FONT:Bold THEN SELF.CharFormat.dwEffects = BOR(SELF.CharFormat.dwEffects, CFE_BOLD).
  IF BAND(fStyle, FONT:Italic)             THEN SELF.CharFormat.dwEffects = BOR(SELF.CharFormat.dwEffects, CFE_ITALIC).
  IF BAND(fStyle, FONT:Underline)          THEN SELF.CharFormat.dwEffects = BOR(SELF.CharFormat.dwEffects, CFE_UNDERLINE).
  IF BAND(fStyle, FONT:Strikeout)          THEN SELF.CharFormat.dwEffects = BOR(SELF.CharFormat.dwEffects, CFE_STRIKEOUT).
  ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_DEFAULT, ADDRESS(SELF.CharFormat)))
  ! --- Set Default Alignment for TextBox -------
  IF SELF.TextBox{PROP:Right}
    SELF.ParaFormat.wAlignment = PFA_RIGHT
  ELSIF SELF.TextBox{PROP:Center}
    SELF.ParaFormat.wAlignment = PFA_CENTER
  ELSE
    SELF.ParaFormat.wAlignment = PFA_LEFT
  END
  SELF.ParaFormat.dwMask = PFM_ALIGNMENT
  ASSERT(SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))
  ! --- Load Default Text Format from Normal.rtt template ---
  SELF.LoadNormalRTT = NormalRTT
  ! -------------------------------------------
  ! --- Create Status Bar ---------------------
  ! -------------------------------------------
  IF StatusBar
    SELF.Setup.StatusBar = TRUE
    IF NOT TextBox{PROP:ReadOnly} AND NOT TextBox{PROP:Disable}
      SELF.ParentWindow{PROP:Status, 1} = -1
      SELF.ParentWindow{PROP:Status, 2} = 80
      SELF.ParentWindow{PROP:Status, 3} = 40
    END
  ELSE
    SELF.Setup.StatusBar = FALSE
  END
  ! --- Set Background Color From TextBox -------
  WM = SendMessage(SELF.RTFhwnd, EM_SETBKGNDCOLOR, 0, fBack)
  ! --- Make sure all is measured in pixels ---
  SELF.Setup.PixelState = SELF.ParentWindow{PROP:Pixels}
  SELF.ParentWindow{PROP:Pixels} = TRUE
  ! -------------------------------------------
  ! --- Create Tabulator Bar ------------------
  ! -------------------------------------------
  IF Tabulator
    ! --- Create Tabulator Region ----
    CtrlEquate = LASTFIELD() + 1
    SELF.TabRegion = CtrlEquate
    CREATE(CtrlEquate, CREATE:Region, TextBox{PROP:Parent})
    CtrlEquate{PROP:Imm} = TRUE
    CtrlEquate{PROP:Bevel, 1} = 1
    UNHIDE(CtrlEquate)
    ! --- Create Tabulator marks -----
    CtrlEquate += 1
    SELF.Setup.Tabulator = CtrlEquate
    LOOP CtrlEquate = SELF.Setup.Tabulator TO SELF.Setup.Tabulator + MAX_TAB_STOPS - 1
      CREATE(CtrlEquate, CREATE:Image, TextBox{PROP:Parent})
      CtrlEquate{PROP:Text} = '~RtfTabMark.bmp'
      CtrlEquate{PROP:Trn} = TRUE
    END
    ! --- Create a Dummy Tabulator ---
    CtrlEquate += 1
    SELF.Setup.DummyXPos = CtrlEquate
    CREATE(CtrlEquate, CREATE:Image, TextBox{PROP:Parent})
    ! --- Create Offset Indent -------
    CtrlEquate += 1
    SELF.Setup.Indent = CtrlEquate
    CREATE(CtrlEquate, CREATE:Image, TextBox{PROP:Parent})
    CtrlEquate{PROP:Text} = '~RtfOffset.bmp'
    UNHIDE(CtrlEquate)
    ! --- Create Start Indent --------
    CtrlEquate += 1
    CREATE(CtrlEquate, CREATE:Image, TextBox{PROP:Parent})
    CtrlEquate{PROP:Text} = '~RtfIndent.bmp'
    UNHIDE(CtrlEquate)
    ! --- Create Right Indent --------
    CtrlEquate += 1
    CREATE(CtrlEquate, CREATE:Image, TextBox{PROP:Parent})
    CtrlEquate{PROP:Text} = '~RtfIndent.bmp'
    UNHIDE(CtrlEquate)
    ! --- Make room for tabulator ----
    TextBox{PROP:YPos}   = TextBox{PROP:YPos} + 23
    TextBox{PROP:Height} = TextBox{PROP:Height} - 23
  END
  ! --- Store Position/Size of TextBox and TabRegion ------
  SELF.Setup.LeftMargin    = 15
  SELF.Setup.RightMargin   = 15
  SELF.Setup.ControlXPos   = SELF.TextBox{PROP:XPos}
  SELF.Setup.ControlYPos   = SELF.TextBox{PROP:YPos}
  SELF.Setup.ControlWidth  = SELF.TextBox{PROP:Width}
  SELF.Setup.ControlHeight = SELF.TextBox{PROP:Height}
  IF SELF.TabRegion
    ! Tabulator Region
    SELF.Setup.TabRegionWidth  = SELF.Setup.ControlWidth 
    SELF.Setup.TabRegionHeight = 19
    SELF.Setup.TabRegionXPos   = SELF.Setup.ControlXPos 
    SELF.Setup.TabRegionYPos   = SELF.Setup.ControlYPos - SELF.Setup.TabRegionHeight - 2
    ! Tabulator Ruler
    SELF.Setup.TabRulerWidth  = SELF.Setup.ControlWidth - SELF.Setup.LeftMargin - SELF.Setup.RightMargin
    SELF.Setup.TabRulerXPos   = SELF.Setup.ControlXPos + SELF.Setup.LeftMargin
  END
  SELF.Setup.WindowWidth   = SELF.ParentWindow{PROP:Width}
  SELF.Setup.WindowHeight  = SELF.ParentWindow{PROP:Height}
  ! --- Return to default pixel state ---------------------
  SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState
  ! --- Call Default Routines -----------------------------
  SELF.Resize

  SELF.CreateFonts
  SELF.CreateFontSize
  SELF.FileName = '(Untitled)'
  SELF.StripName
  ! --- Read the pagesetup to get default page size -------
  SELF.Setup.WordWrap = WordWrap
  CLEAR(SELF.PageSetupDialog)
  SELF.PageSetupDialog.lStructSize = SIZE(SELF.PageSetupDialog)
  SELF.PageSetupDialog.Flags       = PSD_RETURNDEFAULT
  ASSERT(PageSetupDlg(SELF.PageSetupDialog))
  SELF.FormatDoc
  ! --- Calculate alogrithm for tabulatorbar --------------
  ControlDC       = GetDC(SELF.RTFhwnd)
  SELF.Setup.LogX = GetDeviceCaps(ControlDC, LOGPIXELSX)
  ASSERT(ReleaseDC(SELF.RTFhwnd, ControlDC))
  IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
    SELF.Setup.Algorithm = 1440
  ELSE
    SELF.Setup.Algorithm = 1440 / 2.54
  END
  ! --- Remove limitation of text size --------------------
  WM = SendMessage(SELF.RTFhwnd, EM_EXLIMITTEXT, 0, 0FFFFFH)    ! 1 mbyte
  ! --- Clear Modify Flag ---------------------------------
  WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, FALSE, 0)
  ! --- Setup CallBack Window Procedure -------------------
  SavedWndProc = GetWindowLong(SELF.RTFhwnd, GWL_WNDPROC)
  ASSERT(SavedWndProc)
  MsgQueue.WndHwnd = SELF.RTFhwnd
  MsgQueue.WndProc = SavedWndProc
  MsgQueue.WndClass &= SELF
  GET(MsgQueue, MsgQueue.WndHwnd)
  IF ERRORCODE()
    ADD(MsgQueue, MsgQueue.WndHwnd)
  END
  ASSERT(SetWindowLong(SELF.RTFhwnd, GWL_WNDPROC, ADDRESS(WindowsMessage)))
  ! --- Create a new empty document -----------------------
  SELF.NewDoc

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Local Callback Window Message Procedure
!|
WindowsMessage                      PROCEDURE(HWND hWnd, UNSIGNED wMsg, WPARAM wParam, LPARAM lParam)

ReturnValue         LONG

  CODE
 
  MsgQueue.WndHwnd = hWnd
  GET(MsgQueue, MsgQueue.WndHwnd)
  IF ERRORCODE()
    MESSAGE('   It wasn''t posible to find the Rich Edit Control Message Procedure','Message Error',ICON:Hand)
    HALT(0, 'EXIT PROGRAM')
  ELSE
    ReturnValue = CallWindowProc(MsgQueue.WndProc, hWnd, wMsg, wParam, lParam)
    CASE wMsg
    OF WM_KILLFOCUS
      ALIAS(TabKey)
      ALIAS(ShiftTab)
    OF WM_SETFOCUS
      ALIAS(TabKey, CtrlI)
      ALIAS(ShiftTab, CtrlI)
      MsgQueue.WndClass.UpdateWindow
    OF WM_KEYUP OROF WM_LBUTTONDOWN OROF WM_LBUTTONUP OROF WM_WINDOWPOSCHANGED
      MsgQueue.WndClass.UpdateWindow
    END
    MsgQueue.WndClass.WindowEvent(wMsg, wParam, lParam)
    RETURN(ReturnValue)
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Init all buttons and menus used in the rich-edit control
!| ControlType:     Strint to hold type of control (se CASE loop)
!| ControlEquate:   Equate value of control
!| UseMenuIcons:    TRUE - Add icon to menu item, FALSE - Don't add icon
!|
LocRichEditClass.InitButton         PROCEDURE(STRING ControlType, LONG ControlEquate=FALSE, BYTE UseMenuIcons=FALSE)

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.ButtonQueue &= NULL
    SELF.ButtonQueue &= NEW(_BUTTONQUEUE)
  END

  SELF.ButtonQueue.ControlType   = UPPER(CLIP(LEFT(ControlType)))
  GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType)
  IF ERRORCODE()
    IF ControlEquate{PROP:Type} = CREATE:Item
      SELF.ButtonQueue.MenuEquate   = ControlEquate
      SELF.ButtonQueue.ButtonEquate = 0
    ELSE
      SELF.ButtonQueue.MenuEquate   = 0
      SELF.ButtonQueue.ButtonEquate = ControlEquate
    END
    ADD(SELF.ButtonQueue)
  ELSE
    IF ControlEquate{PROP:Type} = CREATE:Item
      ASSERT(NOT SELF.ButtonQueue.MenuEquate)
      SELF.ButtonQueue.MenuEquate   = ControlEquate
    ELSE
      ASSERT(NOT SELF.ButtonQueue.ButtonEquate)
      SELF.ButtonQueue.ButtonEquate = ControlEquate
    END
    PUT(SELF.ButtonQueue)
  END

  IF ControlEquate{PROP:Type} = CREATE:Item
    CASE SELF.ButtonQueue.ControlType
    OF 'LISTOPENEDFILES'
      SELF.CreateFileMenu(9, UseMenuIcons)
    END
  END

  IF ControlEquate{PROP:Type} = CREATE:Item AND UseMenuIcons
    ! --- Make room for the menu icon ---
    SELF.ParentWindow{PROP:Pixels} = TRUE
    ControlEquate{PROP:Left}   = 21
    ControlEquate{PROP:Height} = 21
    SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState
    ! -----------------------------------
    CASE SELF.ButtonQueue.ControlType
    OF 'NEW'
      ControlEquate{PROP:Icon} = '~RtfNew.ico'
    OF 'OPEN'
      ControlEquate{PROP:Icon} = ICON:Open
    OF 'SAVE'
      ControlEquate{PROP:Icon} = ICON:Save
    OF 'SAVEAS'
      ControlEquate{PROP:Icon} = '~RtfSaveAs.ico'
    OF 'PAGESETUP'
      ControlEquate{PROP:Icon} = '~RtfPageSetup.ico'
    OF 'PARAGRAPH'
      ControlEquate{PROP:Icon} = '~RtfParagraph.ico'
    OF 'TABSTOPS'
      ControlEquate{PROP:Icon} = '~RtfTabStops.ico'
    OF 'PRINT'
      ControlEquate{PROP:Icon} = ICON:Print
    OF 'FINDTEXT'
      ControlEquate{PROP:Icon} = '~RtfFind.ico'
    OF 'FINDNEXTTEXT'
      ControlEquate{PROP:Icon} = '~RtfFindNext.ico'
    OF 'REPLACETEXT'
      ControlEquate{PROP:Icon} = '~RtfReplace.ico'
    OF 'COPY'
      ControlEquate{PROP:Icon} = ICON:Copy
    OF 'CUT'
      ControlEquate{PROP:Icon} = ICON:Cut
    OF 'PASTE'
      ControlEquate{PROP:Icon} = ICON:Paste
    OF 'UNDO'
      ControlEquate{PROP:Icon} = '~RtfUndo.ico'
    OF 'REDO'
      ControlEquate{PROP:Icon} = '~RtfRedo.ico'
    OF 'SELECTALL'
      ControlEquate{PROP:Icon} = '~RtfSelectAll.ico'
    OF 'MAILMERGE'
      ControlEquate{PROP:Icon} = '~RtfMailMerge.ico'
    OF 'DATETIME'
      ControlEquate{PROP:Icon} = '~RtfDateTime.ico'
    OF 'URLDETECT'
      ControlEquate{PROP:Icon} = '~RtfUrlDetect.ico'
    OF 'REGULAR'
      ControlEquate{PROP:Icon} = '~RtfRegular.ico'
    OF 'BOLD'
      ControlEquate{PROP:Icon} = '~RtfBold.ico'
    OF 'ITALIC'
      ControlEquate{PROP:Icon} = '~RtfItalic.ico'
    OF 'UNDERLINE'
      ControlEquate{PROP:Icon} = '~RtfUnderline.ico'
    OF 'STRIKEOUT'
      ControlEquate{PROP:Icon} = '~RtfStrikeout.ico'
    OF 'FONT'
      ControlEquate{PROP:Icon} = '~RtfFont.ico'
    OF 'COLOR'
      ControlEquate{PROP:Icon} = '~RtfColor.ico'
    OF 'BACKCOLOR'
      ControlEquate{PROP:Icon} = '~RtfBackColor.ico'
    OF 'LEFT'
      ControlEquate{PROP:Icon} = '~RtfLeft.ico'
    OF 'CENTER'
      ControlEquate{PROP:Icon} = '~RtfCenter.ico'
    OF 'RIGHT'
      ControlEquate{PROP:Icon} = '~RtfRight.ico'
    OF 'BULLET'
      ControlEquate{PROP:Icon} = '~RtfBullet.ico'
    OF 'SINGLE'
      ControlEquate{PROP:Icon} = '~RtfSingle.ico'
    OF 'ONEANDAHALF'
      ControlEquate{PROP:Icon} = '~RtfOneAndAHalf.ico'
    OF 'DOUBLE'
      ControlEquate{PROP:Icon} = '~RtfDouble.ico'
    OF 'SUPERSCRIPT'
      ControlEquate{PROP:Icon} = '~RtfSuperScript.ico'
    OF 'SUBSCRIPT'
      ControlEquate{PROP:Icon} = '~RtfSubScript.ico'
    ELSE
      ControlEquate{PROP:Icon} = '~RtfBlank.ico'
    END
  END

  CASE SELF.ButtonQueue.ControlType
  OF 'LISTFONTS'
    SELF.ButtonQueue.ButtonEquate{PROP:From} = SELF.FontQueue
  OF 'LISTFONTSIZE'
    SELF.ButtonQueue.ButtonEquate{PROP:From} = SELF.FontSizeQueue
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Trap Window Event
!|
LocRichEditClass.TakeWindowEvent    PROCEDURE(*BYTE ReturnValue)

  CODE

  ASSERT(SELF.RTFhwnd)

  CASE EVENT()
  OF EVENT:OpenWindow
    SELF.Resize
  OF EVENT:CLoseWindow OROF EVENT:CloseDown
    IF NOT SELF.Kill(SELF.SaveState)
      ReturnValue = 5   ! Level:Notify
    END
  OF EVENT:GainFocus
    SELF.UpdateWindow
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Trap Field Event
!|
LocRichEditClass.TakeFieldEvent     PROCEDURE()

  CODE
  
  ASSERT(SELF.RTFhwnd)

  CASE EVENT()      ! Trap when TextBox is selected
  OF EVENT:Selected
    IF FIELD() = SELF.TextBox
      SELF.SetFocus
    END
  END

  CASE FIELD()      ! Trap Mouse action on tabulator-bar
  OF SELF.TabRegion
    CASE EVENT()
    OF EVENT:MouseDown
      CASE KEYCODE()
      OF MouseLeft
        SELF.GrapIndent
      OF MouseLeft2
        SELF.JustifyIndent
      END
    OF EVENT:MouseMove
      SELF.DragIndent
    OF EVENT:MouseUp
      SELF.ToggleTabStop
    END
  ELSE
    CASE EVENT()    ! Trap when a button or menu is accepted
    OF EVENT:Accepted

      IF INRANGE(FIELD(), SELF.Setup.MenuFileList, SELF.Setup.MenuFileList + SELF.Setup.MenuFileItems - 1)
        SELF.LoadDoc(SUB(FIELD(){PROP:Text}, 5, 999))
        SELF.UpdateWindow
      END

      IF SELF.ButtonQueue &= NULL
        RETURN
      END

      SELF.ButtonQueue.ButtonEquate = ACCEPTED()
      GET(SELF.ButtonQueue, SELF.ButtonQueue.ButtonEquate)
      IF ERRORCODE()
        SELF.ButtonQueue.MenuEquate = ACCEPTED()
        GET(SELF.ButtonQueue, SELF.ButtonQueue.MenuEquate)
        IF ERRORCODE()
          RETURN
        END
      END

      CASE SELF.ButtonQueue.ControlType
      OF 'NEW'
        SELF.NewDoc
      OF 'OPEN'
        SELF.LoadDoc
      OF 'SAVE'
        SELF.SaveDoc(SELF.FileName)
      OF 'SAVEAS'
        SELF.SaveDoc
      OF 'PAGESETUP'
        SELF.PageSetup
      OF 'PARAGRAPH'
        SELF.Paragraph
      OF 'TABSTOPS'
        SELF.TabStops
      OF 'PRINT'
        SELF.PrintDoc
      OF 'FINDTEXT'
        SELF.ShowToolBox(SELF.ButtonQueue.ControlType)   ! SELF.FindText
      OF 'FINDNEXTTEXT'
        SELF.ShowToolBox(SELF.ButtonQueue.ControlType)   ! SELF.FindText
      OF 'REPLACETEXT'
        SELF.ShowToolBox(SELF.ButtonQueue.ControlType)   ! SELF.ReplaceText
      OF 'COPY'
        SELF.Copy
      OF 'CUT'
        SELF.Cut
      OF 'PASTE'
        SELF.Paste
      OF 'UNDO'
        SELF.Undo
      OF 'REDO'
        SELF.Redo
      OF 'SELECTALL'
        SELF.SelectText
      OF 'MAILMERGE'
        SELF.ShowToolBox(SELF.ButtonQueue.ControlType)   ! SELF.MailMerge
      OF 'DATETIME'
        SELF.ShowToolBox(SELF.ButtonQueue.ControlType)   ! SELF.InsertDateTime
      OF 'LISTFONTS'
        GET(SELF.FontQueue, CHOICE(SELF.ButtonQueue.ButtonEquate))
        SELF.CharFormat.dwMask      = CFM_FACE
        SELF.CharFormat.szFaceName  = SELF.FontQueue.FontName
        ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))
      OF 'LISTFONTSIZE'
        SELF.CharFormat.dwMask      = CFM_SIZE
        SELF.CharFormat.yHeight     = SELF.ButtonQueue.ButtonEquate{PROP:Value} * 20
        ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))
      OF 'REGULAR'
        SELF.ToggleFontStyle(FONT:Regular)
      OF 'BOLD'
        SELF.ToggleFontStyle(FONT:Bold)
      OF 'ITALIC'
        SELF.ToggleFontStyle(FONT:Italic)
      OF 'UNDERLINE'
        SELF.ToggleFontStyle(FONT:Underline)
      OF 'STRIKEOUT'
        SELF.ToggleFontStyle(FONT:Strikeout)
      OF 'FONT'
        SELF.Font
      OF 'COLOR'
        SELF.Color
      OF 'BACKCOLOR'
        SELF.BackColor
      OF 'LEFT'
        SELF.ToggleAlignment(1)
      OF 'CENTER'
        SELF.ToggleAlignment(2)
      OF 'RIGHT'
        SELF.ToggleAlignment(3)
      OF 'BULLET'
        SELF.ToggleBullet(+15)
      OF 'SINGLE'
        SELF.ToggleLineSpace(0)
      OF 'ONEANDAHALF'
        SELF.ToggleLineSpace(1)
      OF 'DOUBLE'
        SELF.ToggleLineSpace(2)
      OF 'URLDETECT'
        SELF.ToggleUrlDetect
      OF 'SUPERSCRIPT'
        SELF.ToggleSubSuperScript(+1)
      OF 'SUBSCRIPT'
        SELF.ToggleSubSuperScript(-1)
      END
      SELF.UpdateWindow
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Set all buttons Flat or Raised
!| FlateState:  TRUE - Flat buttons, FALSE - Normal buttons
!|
LocRichEditClass.FlatButtons        PROCEDURE(BYTE FlatState)

ControlEquate   LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  LOOP ControlEquate = 1 TO RECORDS(SELF.ButtonQueue)
    GET(SELF.ButtonQueue, ControlEquate)
    IF FlatState
      SELF.ButtonQueue.ButtonEquate{PROP:Flat} = TRUE
    ELSE
      SELF.ButtonQueue.ButtonEquate{PROP:Flat} = FALSE
    END
  END
  IF FlatState
    LOOP ControlEquate = 1 TO LASTFIELD()
      IF ControlEquate{PROP:Type} = CREATE:Panel AND ControlEquate{PROP:InToolbar}
        UNHIDE(ControlEquate)
      END
    END
  END

  SELF.Setup.FlatButtons = FlatState

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Prevent buttons from been resized (toolbar-buttons) - ABC Class
!| ResizeClass: Risize Class used in the procedure containing the Rich Edit Control
!|
LocRichEditClass.FixButtons         PROCEDURE(WindowResizeClass ResizeClass, BYTE FixButtons)

ButtonNumber    LONG
ControlEquate   LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF FixButtons
    LOOP ButtonNumber = 1 TO RECORDS(SELF.ButtonQueue)
      GET(SELF.ButtonQueue, ButtonNumber)
      IF NOT SELF.ButtonQueue.ButtonEquate{PROP:InToolBar} AND SELF.ButtonQueue.ButtonEquate{PROP:Type} <> CREATE:Item AND SELF.ButtonQueue.ButtonEquate{PROP:Type} <> CREATE:Menu
        ResizeClass.SetStrategy(SELF.ButtonQueue.ButtonEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
      END
    END
  END

  IF SELF.Setup.Tabulator
    ! --- Don't resize tabulator marks ---
    LOOP ControlEquate = SELF.Setup.Tabulator TO SELF.Setup.Tabulator + MAX_TAB_STOPS - 1
      ResizeClass.SetStrategy(ControlEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
    END
    ! --- Don't resize indent marks ------
    LOOP ControlEquate = SELF.Setup.Indent TO SELF.Setup.Indent + 2
      ResizeClass.SetStrategy(ControlEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Prevent buttons from been resized (toolbar-buttons) - STD Class
!| ResizeClass: Risize Class used in the procedure containing the Rich Edit Control
!|
LocRichEditClass.FixButtonsSTD      PROCEDURE(WindowResizeType ResizeClass, BYTE FixButtons)

ButtonNumber    LONG
ControlEquate   LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF FixButtons
    LOOP ButtonNumber = 1 TO RECORDS(SELF.ButtonQueue)
      GET(SELF.ButtonQueue, ButtonNumber)
      IF NOT SELF.ButtonQueue.ButtonEquate{PROP:InToolBar} AND SELF.ButtonQueue.ButtonEquate{PROP:Type} <> CREATE:Item AND SELF.ButtonQueue.ButtonEquate{PROP:Type} <> CREATE:Menu
        ResizeClass.SetControlStrategy(SELF.ButtonQueue.ButtonEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
      END
    END
  END

  IF SELF.Setup.Tabulator
    ! --- Don't resize tabulator marks ---
    LOOP ControlEquate = SELF.Setup.Tabulator TO SELF.Setup.Tabulator + MAX_TAB_STOPS - 1
      ResizeClass.SetControlStrategy(ControlEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
    END
    ! --- Don't resize indent marks ------
    LOOP ControlEquate = SELF.Setup.Indent TO SELF.Setup.Indent + 2
      ResizeClass.SetControlStrategy(ControlEquate, Resize:LockXPos + Resize:LockYPos, Resize:LockSize)
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Create a Listing of Last Opened Files on a Menu
!|
LocRichEditClass.CreateFileMenu     PROCEDURE(BYTE MenuItems, BYTE UseMenuIcons=FALSE)

Count           LONG
MenuEquate      LONG
LastFieldNo     LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  ! --- Use old menu hide system ---
  SYSTEM{PROP:compatibility} = 1

  SELF.Setup.MenuFileItems = MenuItems

  LastFieldNo = LASTFIELD()
  SELF.Setup.MenuFileList = LastFieldNo + 1

  LOOP Count = 1 TO MenuItems
    MenuEquate = LastFieldNo + Count
    CREATE(MenuEquate, CREATE:Item, SELF.ButtonQueue.MenuEquate{PROP:Parent}, SELF.ButtonQueue.MenuEquate - SELF.ButtonQueue.MenuEquate{PROP:Parent} + Count - 1)
    IF UseMenuIcons
      SELF.ParentWindow{PROP:Pixels} = TRUE
      MenuEquate{PROP:Left}   = 8
      SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState
    END
  END
  DESTROY(SELF.ButtonQueue.MenuEquate)

  SELF.UpdateFileMenu

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Update the file menu from the INI-File
!|
LocRichEditClass.UpdateFileMenu     PROCEDURE(<STRING FileToDelete>)

FileQueue           QUEUE
FilePath              CSTRING(256)
                    END
Count               LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.Setup.MenuFileItems

    HIDE(SELF.Setup.MenuFileList, SELF.Setup.MenuFileList + SELF.Setup.MenuFileItems - 1)
    ENABLE(SELF.Setup.MenuFileList, SELF.Setup.MenuFileList + SELF.Setup.MenuFileItems - 1)

    ! --- Read all files from ini-file ----------------------
    FREE(FileQueue)
    LOOP Count = 1 TO SELF.Setup.MenuFileItems
      FileQueue.FilePath = GETINI('FILELIST', 'FILE_' & Count, '', '.\RichEdit.ini')
      IF FileQueue.FilePath
        GET(FileQueue, FileQueue.FilePath)
        IF ERRORCODE()
          ADD(FileQueue)
        END
      ELSE
        BREAK
      END
    END
    ! --- Delete or Add File to List and save List --------
    IF FileToDelete
      ! --- DELETE ---
      FileQueue.FilePath = FileToDelete
      GET(FileQueue, FileQueue.FilePath)
      IF NOT ERRORCODE()
        DELETE(FileQueue)
      END
    ELSE
      ! --- ADD ------
      IF SELF.FileName AND SELF.FileName <> '(Untitled)'
        FileQueue.FilePath = SELF.FileName
        GET(FileQueue, FileQueue.FilePath)
        IF NOT ERRORCODE()
          DELETE(FileQueue)
        END
        ADD(FileQueue, 1)
      END
    END
    ! --- Update the File List Menu and save the List -------
    LOOP Count = 1 TO SELF.Setup.MenuFileItems
      GET(FileQueue, Count)
      IF ERRORCODE()
        PUTINI('FILELIST', 'FILE_' & Count, '', '.\RichEdit.ini')
      ELSE
        PUTINI('FILELIST', 'FILE_' & Count, FileQueue.FilePath, '.\RichEdit.ini')
        (SELF.Setup.MenuFileList + Count - 1){PROP:Text} = '&' & Count & '  ' &FileQueue.FilePath
        UNHIDE(SELF.Setup.MenuFileList + Count - 1)
      END
    END
    IF NOT RECORDS(FileQueue)
      SELF.Setup.MenuFileList{PROP:Text} = '(No Last Opened Files)'
      UNHIDE(SELF.Setup.MenuFileList)
      DISABLE(SELF.Setup.MenuFileList)
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Show or hide Rich Edit Control
!| ShowState:   TRUE - Rich Edit Control Visible, FALSE - Rich Edit Control Hided
!|
LocRichEditClass.ShowWindow         PROCEDURE(BYTE ShowState)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF ShowState
    WM = ShowWindow(SELF.RTFhwnd, SW_SHOW)
  ELSE
    WM = ShowWindow(SELF.RTFhwnd, SW_HIDE)
  END

  BLANK()
  SELF.Resize
  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  CheckModify:    Kill the Rich Edit Control - if CheckModify is TRUE the function asks for save of the Rich Edit Control
!|                  before kill, if the control is modified.
!|
LocRichEditClass.Kill               PROCEDURE(BYTE CheckModify)

ReturnValue     BOOL(TRUE)
BreakTime       LONG
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  ! --- Close all opened Threads ---
  IF SELF.Setup.PopupMailMerge
    POST(EVENT:CloseWindow,, SELF.Setup.PopupMailMerge, 1)
    ! --- Give the Popup Window time to undock and close down
    BreakTime = CLOCK() + 20
    ACCEPT
      IF BreakTime < CLOCK()
        BREAK
      END
      POST(EVENT:Last)
    END
  END
  IF SELF.Setup.PopupFindText
    POST(EVENT:CloseWindow,, SELF.Setup.PopupFindText, 1)
  END
  IF SELF.Setup.PopupReplaceText
    POST(EVENT:CloseWindow,, SELF.Setup.PopupReplaceText, 1)
  END
  IF SELF.Setup.PopupDateTime
    POST(EVENT:CloseWindow,, SELF.Setup.PopupDateTime, 1)
  END
  IF SELF.Setup.PopupMailInsert                              !bk
    POST(EVENT:CloseWindow,, SELF.Setup.PopupMailInsert, 1)  !bk
  END                                                        !bk

  ! --- Make sure that all devices is released ---
  WM = DeleteDC(SELF.PrintDialog.hDC)
  WM = DeleteDC(SELF.Setup.PrinterHDC)

  ! --- If document is saved then free all queues ---
  IF CheckModify
    IF SELF.MailFileOpen
      SELF.MailScreen(FALSE)
    END
    IF NOT SELF.SaveModified()
      RETURN(FALSE)
    ELSE
      DO FreeMemory
    END
  ELSE
    DO FreeMemory
  END

FreeMemory  ROUTINE

  IF RECORDS(MsgQueue)
    MsgQueue.WndHwnd = SELF.RTFhwnd
    GET(MsgQueue, MsgQueue.WndHwnd)
    IF NOT ERRORCODE()
      ASSERT(SetWindowLong(SELF.RTFhwnd, GWL_WNDPROC, MsgQueue.WndProc))
      DELETE(MsgQueue)
    END
  END

  IF NOT SELF.MailFileQueue &= NULL
    DISPOSE(SELF.MailFileQueue)
  END
  IF NOT SELF.ButtonQueue &= NULL
    DISPOSE(SELF.ButtonQueue)
  END
  IF NOT FontQueue &= NULL
    DISPOSE(FontQueue)
  END
  IF NOT SELF.FontQueue &= NULL
     DISPOSE(SELF.FontQueue)
  END
  IF NOT SELF.FontSizeQueue &= NULL
    DISPOSE(SELF.FontSizeQueue)
  END

  RETURN(TRUE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Limit the size of the Rich Edit Control for use with memo fields
!|  TextSize:   Size of Rich Edit Text, if 0 the size is set to maximum.
!|
LocRichEditClass.LimitSize          PROCEDURE(LONG TextSize)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, EM_EXLIMITTEXT, 0, TextSize)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Select text in the Rich Edit Control
!|  Direction:  (none) - Select all text, +1 - Select all text from cursor and forward, -1 - Select all text from cursor and backward
!|
LocRichEditClass.SelectText         PROCEDURE(<SHORT Direction>)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
  IF Direction < 0
    SELF.CharRange.cpMin =  0
  ELSIF Direction > 0
    SELF.CharRange.cpMax = -1
  ELSE
    SELF.CharRange.cpMin =  0
    SELF.CharRange.cpMax = -1
  END
  WM = SendMessage(SELF.RTFhwnd, EM_EXSETSEL, 0, ADDRESS(SELF.CharRange))

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Set focus to the Rich Edit Control
!|
LocRichEditClass.SetFocus           PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)
 
  WM = SetFocus(SELF.RTFhwnd)
 
! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Resize the Rich Edit Control and the Tabulator bar
!|
LocRichEditClass.Resize             PROCEDURE()

WinHandle           LONG
CtrlEquate          LONG
PrintChar           CSTRING(3)
Distance            REAL
Counter             LONG
Position            SREAL
MaxWidth            LONG
Quater              BYTE
DoBreak             BOOL
UseInch             BOOL(FALSE)
Space               BYTE
WinDowRect          LIKE(_RECT)

  CODE
  
  ASSERT(SELF.RTFhwnd)

  IF IsWindowVisible(SELF.RTFhwnd)
  ! -- Set Size and Resize Rich Edit Control --
  SELF.ParentWindow{PROP:Pixels} = TRUE
  MoveWindow(SELF.RTFHwnd, SELF.Setup.ControlXPos , SELF.Setup.ControlYPos, INT(SELF.Setup.ControlWidth + SELF.ParentWindow{PROP:Width} - SELF.Setup.WindowWidth) - SELF.Setup.DockedWidth, INT(SELF.Setup.ControlHeight + SELF.ParentWindow{PROP:Height} - SELF.Setup.WindowHeight) - SELF.Setup.DockedHeight, TRUE)
  SELF.ParentWindow{PROP:Pixels} = TRUE
  END

  IF SELF.Setup.Tabulator AND IsWindowVisible(SELF.RTFhwnd)

    ! --- Prepare for 'Is vertical scrollbar visible' ---
    ASSERT(GetWindowRect(SELF.RTFhwnd, WindowRect))
    SELF.Setup.WindowRectWidth = WindowRect.Right - WindowRect.Left

    ! --- Set Size and Resize Tabulator region ---
    CtrlEquate = SELF.TabRegion
    WinHandle = CtrlEquate{PROP:Handle}
    MoveWindow(WinHandle, SELF.Setup.ControlXPos , SELF.Setup.TabRegionYPos, INT(SELF.Setup.ControlWidth + SELF.ParentWindow{PROP:Width} - SELF.Setup.WindowWidth), SELF.Setup.TabRegionHeight, TRUE)
    SELF.ParentWindow{PROP:Pixels} = TRUE
    SELF.Setup.TabRegionXPos   = SELF.TabRegion{PROP:XPos}
    SELF.Setup.TabRegionYPos   = SELF.TabRegion{PROP:YPos}
    SELF.Setup.TabRegionWidth  = SELF.TabRegion{PROP:Width}
    SELF.Setup.TabRegionHeight = SELF.TabRegion{PROP:Height}

    SELF.Setup.TabRulerXPos  = SELF.Setup.TabRegionXPos  + SELF.Setup.LeftMargin
    IF SELF.Setup.HScroll
      SELF.Setup.TabRulerWidth = (SELF.FormatRange.rc.right - SELF.FormatRange.rc.left) / 1440 * SELF.Setup.LogX
    ELSE
      SELF.Setup.TabRulerWidth = SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin - SELF.Setup.RightMargin
    END

    IF SELF.Setup.TabRulerWidth > SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin
      SELF.Setup.TabRulerWidth = SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin
    END

    ! --- Hide Tabs outside ruler ---
    LOOP CtrlEquate = SELF.Setup.Tabulator TO SELF.Setup.Tabulator + MAX_TAB_STOPS - 1
      IF CtrlEquate{PROP:XPos} > 0
        IF INRANGE(CtrlEquate{PROP:XPos}, SELF.Setup.TabRulerXPos + 5, SELF.Setup.TabRulerXPos + SELF.Setup.TabRulerWidth - 5)
          CtrlEquate{PROP:Hide} = FALSE
        ELSE
          CtrlEquate{PROP:Hide} = TRUE
        END
      END
    END

    SELF.UpdateTabulator
    SELF.UpdateRuler

  END

  SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Create a new blank document
!|
LocRichEditClass.NewDoc             PROCEDURE()

WM              LONG
TextString      CSTRING('')

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.SaveModified()

    SELF.CharFormat.dwMask = 0FFFFFFFFH
    SELF.ParaFormat.dwMask = 0FFFFFFFFH

    IF SELF.Setup.FirstTimerNewDoc
      SELF.Setup.FirstTimerNewDoc = FALSE
      ASSERT(SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_DEFAULT, ADDRESS(SELF.CharFormat)))
      ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))
      SELF.ParaFormat.cTabCount = 0
      SELF.Setup.DefaultCharFormat :=: SELF.CharFormat
      SELF.Setup.DefaultParaFormat :=: SELF.ParaFormat
    END
    SELF.CharFormat :=: SELF.Setup.DefaultCharFormat
    SELF.ParaFormat :=: SELF.Setup.DefaultParaFormat
    ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))
    WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

    WM = SendMessage(SELF.RTFhwnd, EM_SETMARGINS, EC_LEFTMARGIN + EC_RIGHTMARGIN, SELF.Setup.RightMargin * 256^2 + SELF.Setup.LeftMargin)
    WM = SendMessage(SELF.RTFhwnd, WM_SETTEXT, 0, ADDRESS(TextString))
    WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, FALSE, 0)

    IF SELF.LoadNormalRTT
      SELF.LoadDoc('Normal.rtt')
    END
    SELF.FileName = '(Untitled)'
    RTFStreamFileName = ''
    SELF.StripName
  END

  SELF.UpdateWindow

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Load a document from the file-dialog.
!|  FileName:   If FileName is used, this file is loaded without use of the filedialog.
!|  FieldName:  If FieldName is used, the file is loaded form a file database
!|
LocRichEditClass.LoadDoc            PROCEDURE(<STRING FileName>, <*STRING FieldName>)

TextType        UNSIGNED
CookieAddress   ULONG
HoldPath        CSTRING(256)
SaveOptions     CSTRING(256)
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF OMITTED(3) ! Make sure Mail Merge is closed when try to load a file in normal way.
    SELF.MailScreen(FALSE)
  END

  IF SELF.SaveModified()

    IF SELF.SaveExtension
      SaveOptions = SELF.SaveExtension
    ELSE
      IF SELF.SaveTextFormat
        SaveOptions = 'Tekstdocuments (*.txt)|*.TXT'
      ELSE
        SaveOptions = 'Rich Text Format (*.rtf)|*.RTF|Rich Text Template (*.rtt)|*.RTT|Tekstdocuments (*.txt)|*.TXT'
      END
    END

    IF OMITTED(2) AND OMITTED(3)
      HoldPath = PATH()
      SETPATH(SELF.Setup.DefaultPath)
      IF NOT FILEDIALOG(,RTFStreamFileName, SaveOptions & '|All Files (*.*)|*.*',10010b)
        SELF.SetFocus
        RETURN
      END
      RTFStreamExt      = UPPER(SUB(RTFStreamFileName, INSTRING('.', RTFStreamFileName,1,1), 4))
      CookieAddress     = 0
      SETPATH(HoldPath)
    ELSIF NOT OMITTED(2)
      RTFStreamFileName = FileName
      RTFStreamExt      = UPPER(SUB(RTFStreamFileName, INSTRING('.', RTFStreamFileName,1,1), 4))
      CookieAddress     = 0
    ELSIF NOT OMITTED(3)
      RTFStreamFileName = ''
      RTFStreamExt      = '.RTF'
      CookieAddress     = ADDRESS(FieldName)
      StreamPointer     = 0
      StreamLength      = LEN(CLIP(FieldName))
    END

    IF RTFStreamFileName
      OPEN(RTFStreamFile, 42H)
      IF ERRORCODE()
        IF UPPER(ERRORFILE()) = 'NORMAL.RTT'
          SELF.FileName = 'Normal.rtt'
          SELF.SaveDoc('Normal.rtt')
        ELSE
          BEEP(SELF.Setup.WarningSound)
          MESSAGE('   Error reading file: ' & ERRORFILE(), 'Read Error', ICON:EXCLAMATION)
          SELF.UpdateFileMenu(FileName)
          SELF.SetFocus
        END
        RETURN
      END
      STREAM(RTFStreamFile)
      SET(RTFStreamFile)
    END

    SELF.EditStream.dwCookie    = CookieAddress
    SELF.EditStream.pfnCallBack = ADDRESS(StreamLoad)
    SELF.EditStream.dwError     = 0

    IF INLIST(RTFStreamExt, '.RTF', '.RTT') AND NOT SELF.SaveTextFormat
      TextType = SF_RTF
    ELSE
      TextType = SF_TEXT
    END

    SETCURSOR(CURSOR:Wait)

    WM = SendMessage(SELF.RTFhwnd, EM_STREAMIN, TextType, ADDRESS(SELF.EditStream))
    IF TextType = SF_RTF AND SELF.EditStream.dwError
      TextType = SF_TEXT
      StreamPointer = 0
      WM = SendMessage(SELF.RTFhwnd, EM_STREAMIN, TextType, ADDRESS(SELF.EditStream))
      IF SELF.EditStream.dwError
      BEEP(SELF.Setup.WarningSound)
        MESSAGE('   It was not posible to read the stream','Read Error', ICON:Exclamation)
        CLEAR(RTFStreamFileName)
      END
    END

    SETCURSOR()

    IF RTFStreamFileName
      CLOSE(RTFStreamFile)
      IF RTFStreamExt = '.RTT'  ! Loading template
        SELF.FileName = '(Untitled)'
        RTFStreamFileName = ''
      ELSE                      ! Loading normal file
        SELF.FileName = RTFStreamFileName
      END
      SELF.StripName
    ELSE
      SELF.FileName = ''
      SELF.StripName
    END

    WM = SendMessage(SELF.RTFhwnd, EM_EMPTYUNDOBUFFER, 0, 0)
    WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, FALSE, 0)

    SELF.UpdateFileMenu

  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Internal procedure. Used to load a document into a stream.
!|
StreamLoad                          PROCEDURE(ULONG dwCookie, ULONG pbBuff, ULONG cb, *ULONG pcb)

PeekChar        BYTE
Counter         LONG

  CODE

  CLEAR(pcb)
  
  IF dwCookie   ! Read from file field
    LOOP
      PEEK(dwCookie + StreamPointer, PeekChar)
      StreamPointer += 1
      IF StreamPointer >= StreamLength
        BREAK
      END
      POKE(pbBuff + pcb, PeekChar)
      pcb += 1
      IF pcb = cb
        BREAK
      END
    END
  ELSE          ! Read from disk file
    NEXT(RTFStreamFile)
    IF NOT ERRORCODE()
      LOOP Counter = 1 TO BYTES(RTFStreamFile)
        POKE(pbBuff + pcb, RTFStreamFile.Stream[Counter])
        pcb += 1
        IF pcb = cb
          SET(RTFStreamFile, POINTER(RTFStreamFile) + pcb)
          BREAK
        END
      END
    ELSIF ERRORCODE() = NotOpenErr
      RETURN(TRUE)
    END
  END

  RETURN(FALSE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Save a document to the file-dialog.
!|  FileName:   If FileName is used, this file is saved without use of the filedialog.
!|  FieldName:  If FieldName is used, the file is saved to a file database
!|
LocRichEditClass.SaveDoc            PROCEDURE(<STRING FileName>, <*STRING FieldName>)

TextType        UNSIGNED
CookieAddress   ULONG
HoldPath        CSTRING(256)
SaveOptions     CSTRING(256)
NewExtension    CSTRING(5)
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.SaveExtension
    SaveOptions = SELF.SaveExtension
    NewExtension = UPPER(SUB(SaveOptions, INSTRING('.', SaveOptions, 1, 1), 4))
  ELSE
    IF SELF.SaveTextFormat
      SaveOptions = 'Tekstdocuments (*.txt)|*.TXT'
    ELSE
      SaveOptions = 'Rich Text Format (*.rtf)|*.RTF|Rich Text Template (*.rtt)|*.RTT|Tekstdocuments (*.txt)|*.TXT'
    END
  END

  IF OMITTED(2) AND OMITTED(3) OR SELF.FileName = '(Untitled)'
    HoldPath = PATH()
    SETPATH(SELF.Setup.DefaultPath)
    IF NOT FILEDIALOG(,RTFStreamFileName, SaveOptions,10011b)
      SELF.SetFocus
      RETURN
    END
    RTFStreamExt      = UPPER(SUB(RTFStreamFileName, INSTRING('.', RTFStreamFileName,1,1), 4))
    CookieAddress     = 0
    SETPATH(HoldPath)
  ELSIF NOT OMITTED(2)
    RTFStreamFileName = FileName
    RTFStreamExt      = UPPER(SUB(RTFStreamFileName, INSTRING('.', RTFStreamFileName,1,1), 4))
    CookieAddress     = 0
  ELSIF NOT OMITTED(3)
    RTFStreamFileName = ''
    RTFStreamExt      = '.RTF'
    CookieAddress     = ADDRESS(FieldName)
    StreamPointer     = 0
    StreamLength      = SIZE(FieldName)
  END

  IF RTFStreamFileName
    IF RTFStreamExt
      IF SELF.SaveExtension
        IF NOT RTFStreamExt = NewExtension
          BEEP(SELF.Setup.WarningSound)
          MESSAGE('   Unknown file extension: "' & RTFStreamExt & '"|   Extension must be *' & NewExtension, 'Save Error', ICON:Exclamation)
          SELF.SetFocus
          RETURN
        END
      ELSE
        IF SELF.SaveTextFormat
          IF NOT RTFStreamExt = '.TXT'
            BEEP(SELF.Setup.WarningSound)
            MESSAGE('   Unknown file extension: "' & RTFStreamExt & '"|   Extension must be *.TXT', 'Save Error', ICON:Exclamation)
            SELF.SetFocus
            RETURN
          END
        ELSE
          IF NOT INLIST(RTFStreamExt, '.RTF', '.RTT', '.TXT')
            BEEP(SELF.Setup.WarningSound)
            MESSAGE('   Unknown file extension: "' & RTFStreamExt & '"|   Extension must be *.RTF, *.RTT or *.TXT', 'Save Error', ICON:Exclamation)
            SELF.SetFocus
            RETURN
          END
        END
      END
    ELSE
      IF SELF.SaveExtension
        RTFStreamExt = NewExtension
        RTFStreamFileName = RTFStreamFileName & LOWER(NewExtension)
      ELSE
        IF SELF.SaveTextFormat
          RTFStreamExt = '.TXT'
          RTFStreamFileName = RTFStreamFileName & '.txt'
        ELSE
          RTFStreamExt = '.RTF'
          RTFStreamFileName = RTFStreamFileName & '.rtf'
        END
      END
    END
    CREATE(RTFStreamFile)
    IF ERRORCODE()
      BEEP(SELF.Setup.WarningSound)
      MESSAGE('   Error creating file: ' & ERRORFILE(), 'Save Error', ICON:Exclamation)
      SELF.SetFocus
      RETURN
    ELSE
      OPEN(RTFStreamFile, 42H)
      IF ERRORCODE()
        BEEP(SELF.Setup.WarningSound)
        MESSAGE('   Error saving file: ' & ERRORFILE(), 'Save Error', ICON:Exclamation)
        SELF.SetFocus
        RETURN
      END
    END
    STREAM(RTFStreamFile)
    SET(RTFStreamFile)
  END

  SELF.EditStream.dwCookie    = CookieAddress
  SELF.EditStream.pfnCallBack = ADDRESS(StreamSave)
  SELF.EditStream.dwError     = 0

  IF INLIST(RTFStreamExt, '.RTF', '.RTT') AND NOT SELF.SaveTextFormat
    TextType = SF_RTF
  ELSE
    TextType = SF_TEXT
  END

  SETCURSOR(CURSOR:Wait)
 
  WM = SendMessage(SELF.RTFhwnd, EM_STREAMOUT, TextType, ADDRESS(SELF.EditStream))
  IF TextType = SF_RTF AND SELF.EditStream.dwError
    TextType = SF_TEXT
    StreamPointer = 0
    WM = SendMessage(SELF.RTFhwnd, EM_STREAMOUT, TextType, ADDRESS(SELF.EditStream))
    IF SELF.EditStream.dwError
      BEEP(SELF.Setup.WarningSound)
      MESSAGE('   It was not posible to save the file.','Save Error', ICON:Exclamation)
      CLEAR(RTFStreamFileName)
    END
  END

  SETCURSOR()

  IF RTFStreamFileName
    CLOSE(RTFStreamFile)
    SELF.FileName = RTFStreamFileName
    SELF.StripName
  ELSE
    SELF.FileName = ''
    SELF.StripName
  END

  WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, FALSE, 0)

  SELF.UpdateFileMenu

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Internal procedure. Used to save a document into a stream.
!|
StreamSave                          PROCEDURE(ULONG dwCookie, ULONG pbBuff, ULONG cb, *ULONG pcb)

PeekChar        BYTE
Counter         LONG
RecordLen       LONG

  CODE

  CLEAR(pcb)

  IF dwCookie   ! Write to file field
    LOOP
      PEEK(pbBuff + pcb, PeekChar)
      POKE(dwCookie + StreamPointer, PeekChar)
      StreamPointer += 1
      IF StreamPointer = StreamLength
        BEEP(BEEP:SystemExclamation)
        MESSAGE('   The field variable is to small to hold the document.', 'Stream Error', ICON:Exclamation)
        RETURN(TRUE)
      END
      pcb += 1
      IF pcb = cb
        BREAK
      END
    END
  ELSE          ! Write to disk file
    RecordLen = SIZE(RTFStreamFile.Stream) - 1
    LOOP
      CLEAR(RTFStreamFile.Stream)
      LOOP Counter = 1 TO RecordLen
        PEEK(pbBuff + pcb, RTFStreamFile.Stream[Counter])
        pcb += 1
        IF pcb = cb
          ADD(RTFStreamFile, Counter)
          RETURN(FALSE)
        END
      END
      ADD(RTFStreamFile, RecordLen)
    END
  END

  RETURN(FALSE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Check if document is modified and then asks to save the document.
!|
LocRichEditClass.SaveModified       PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.MailDocumentBuffer
    RETURN(TRUE)
  ELSE
    LOOP
      IF SendMessage(SELF.RTFhwnd, EM_GETMODIFY, 0, 0)
        BEEP(SELF.Setup.WarningSound)
        CASE MESSAGE('   Do you want to save modified document.','Save Document',ICON:Exclamation,BUTTON:Yes+BUTTON:No+BUTTON:Cancel)
        OF BUTTON:Yes
          SELF.SaveDoc
          CYCLE
        OF BUTTON:No
          BREAK
        OF BUTTON:Cancel
          SELF.SetFocus
          RETURN(FALSE)
        END
      ELSE
        BREAK
      END
    END
  END

  RETURN(TRUE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Update all tabstops for pressent paragraph.
!|
LocRichEditClass.UpdateTabulator    PROCEDURE()

TabPos          LONG
TabNo           LONG
CtrlNo          LONG
OldPixelState   BOOL
RightOffset     LONG
ClientRect      LIKE(_RECT)
WindowRect      LIKE(_RECT)
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.ParentWindow{PROP:Pixels} = TRUE

  IF SELF.Setup.Tabulator
    SELF.ParaFormat.dwMask = PFM_TABSTOPS
    ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))

    TabNo = 0
    LOOP CtrlNo = SELF.Setup.Tabulator TO SELF.Setup.Tabulator + MAX_TAB_STOPS - 1
      TabNo += 1
      TabPos = INT(SELF.ParaFormat.rgxTabs[TabNo] * SELF.Setup.LogX / 1440) + SELF.Setup.TabRulerXPos + 2
      IF CtrlNo{PROP:XPos} <> TabPos
        IF TabPos = 0
          CtrlNo{PROP:Hide} = TRUE
          CtrlNo{PROP:XPos} = TabPos
        ELSE
          CtrlNo{PROP:XPos} = TabPos
          CtrlNo{PROP:Hide} = FALSE
        END
      END
      CtrlNo{PROP:YPos} = SELF.Setup.TabRegionYPos + 10
    END

    ! --- Is Vertical Scrollbar Visible? - If visible increase offset with width of scrollbar.
    ASSERT(GetClientRect(SELF.RTFhwnd, ClientRect))
    IF ClientRect.Right + 10 < SELF.Setup.WindowRectWidth
      IF SELF.Setup.HScroll
        RightOffset = 120
      ELSE
        RightOffset = 300
      END
    ELSE
      RightOffset = 120
    END

    LOOP CtrlNo = SELF.Setup.Indent TO SELF.Setup.Indent + 2
      CASE CtrlNo - SELF.Setup.Indent
      OF 0
        CtrlNo{PROP:XPos} = SELF.Setup.TabRulerXPos + SELF.ParaFormat.dxStartIndent * SELF.Setup.LogX / 1440
        CtrlNo{PROP:YPos} = SELF.Setup.TabRegionYPos + 2
      OF 1
        CtrlNo{PROP:XPos} = SELF.Setup.TabRulerXPos + (SELF.ParaFormat.dxStartIndent + SELF.ParaFormat.dxOffset) * SELF.Setup.LogX / 1440
        CtrlNo{PROP:YPos} = SELF.Setup.TabRegionYPos + 10
      OF 2
        CtrlNo{PROP:XPos} = SELF.Setup.TabRulerXPos + SELF.Setup.TabRulerWidth - (SELF.ParaFormat.dxRightIndent + RightOffset) * SELF.Setup.LogX / 1440
        CtrlNo{PROP:YPos} = SELF.Setup.TabRegionYPos + 10
      END
      IF INRANGE(CtrlNo{PROP:XPos}, SELF.Setup.TabRulerXPos, SELF.Setup.TabRulerXPos + SELF.Setup.TabRulerWidth - CtrlNo{PROP:Width})
        UNHIDE(CtrlNo)
      ELSE
        HIDE(CtrlNo)
      END
    END

  END

  SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Update the ruler after resize and format document
!|
LocRichEditClass.UpdateRuler        PROCEDURE()

MaxWidth            LONG
Distance            REAL
UseInch             BOOL(FALSE)
Counter             LONG
PrintChar           CSTRING(3)
Quater              BYTE
Space               BYTE
DoBreak             BOOL
Position            SREAL

  CODE
 
  ASSERT(SELF.RTFhwnd)

  SELF.ParentWindow{PROP:Pixels} = TRUE

  IF SELF.Setup.Tabulator AND IsWindowVisible(SELF.RTFhwnd)

    ! --- Erase old ruler ---
    BLANK(SELF.Setup.TabRegionXPos - 2, SELF.Setup.TabRegionYPos - 2, , SELF.Setup.TabRegionHeight + 4)

    ! --- Paint new ruler ---
    IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
      UseInch = TRUE
    END

    MaxWidth = SELF.Setup.TabRulerWidth
    Distance = SELF.Setup.LogX / 2.54
    IF UseInch
      Distance = SELF.Setup.LogX
    END
    LOOP Counter = 0 TO 50
      Position = Counter * Distance
      IF Counter > 0
        IF UseInch THEN PrintChar = ':';   Quater = 1; DO DrawRuler; IF DoBreak THEN BREAK..
        PrintChar = '|';   Quater = 2; DO DrawRuler; IF DoBreak THEN BREAK.
        IF UseInch THEN PrintChar = ':';   Quater = 3; DO DrawRuler; IF DoBreak THEN BREAK..
      END
      PrintChar = Counter; Quater = 4; DO DrawRuler; IF DoBreak THEN BREAK.
    END

  END

  SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState

DrawRuler       ROUTINE

  DoBreak = FALSE
  IF Quater < 4 THEN Space = 1 ELSE Space = 3.
  IF 2 + (Position - Distance) + Distance * Quater / 4 + LEN(PrintChar) * Space >= MaxWidth
    DoBreak = TRUE
  ELSE
    SHOW(SELF.Setup.TabRulerXPos + 2 + (Position - Distance) + Distance * Quater / 4 - LEN(PrintChar) * Space, SELF.Setup.TabRegionYPos + 1, PrintChar)
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Print the current document
!|  ShowDialog: If TRUE the print dialag is shown, otherwise the document is printet without the print dialog.
!|
LocRichEditClass.PrintDoc           PROCEDURE(BYTE ShowDialog=TRUE)

LogX            LONG
LogY            LONG
PageWidth       LONG
PageHeight      LONG
MaxChar         LONG
MaxCharx        LONG
OutChar         LONG
OldMap          LONG
DocInfo         LIKE(_DOCINFO)
DocName         CSTRING(256)
CharRange       LIKE(_CHARRANGE)
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)

    CLEAR(SELF.PrintDialog)
    SELF.PrintDialog.lStructSize = SIZE(SELF.PrintDialog)
    SELF.PrintDialog.hwndOwner   = SELF.RTFhwnd
    SELF.PrintDialog.hDevMode    = SELF.PageSetupDialog.hDevMode
    SELF.PrintDialog.Flags       = PD_RETURNDC + PD_NOPAGENUMS + PD_NOSELECTION + PD_PRINTSETUP

    IF SELF.MailFileOpen AND SELF.Setup.PrinterHDC  ! If Mail File is open and printer has been used before, then use old hDc
      SELF.PrintDialog.hDC = SELF.Setup.PrinterHDC
    ELSE
      WM = PrintDlg(SELF.PrintDialog)
      IF SELF.MailFileOpen                          ! Save hDC if Mail File is open for later use in Mail File
        SELF.Setup.PrinterHDC = SELF.PrintDialog.hDC
      END
    END

    IF SELF.PrintDialog.hDC
 
      SELF.PageSetupDialog.hDevMode = SELF.PrintDialog.hDevMode

      LogX       = GetDeviceCaps(SELF.PrintDialog.hDC, LOGPIXELSX)
      LogY       = GetDeviceCaps(SELF.PrintDialog.hDC, LOGPIXELSY)
      PageWidth  = GetDeviceCaps(SELF.PrintDialog.hDC, HORZRES)
      PageHeight = GetDeviceCaps(SELF.PrintDialog.hDC, VERTRES)

      CLEAR(SELF.FormatRange)
      SELF.FormatRange.hdc        =  SELF.PrintDialog.hDC
      SELF.FormatRange.hdcTarget  =  SELF.PrintDialog.hDC
      ! --- Set page size
      SELF.FormatRange.rc.left    =  0
      SELF.FormatRange.rc.top     =  0
      SELF.FormatRange.rc.right   =  (PageWidth  / LogX) * 1440
      SELF.FormatRange.rc.bottom  =  (PageHeight / LogY) * 1440

      ! --- Set page margins
      IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
        SELF.FormatRange.rc.left   += (SELF.PageSetupDialog.rtMargin.left   / 1000 * 1440)
        SELF.FormatRange.rc.top    += (SELF.PageSetupDialog.rtMargin.top    / 1000 * 1440)
        SELF.FormatRange.rc.right  -= (SELF.PageSetupDialog.rtMargin.right  / 1000 * 1440)
        SELF.FormatRange.rc.bottom -= (SELF.PageSetupDialog.rtMargin.bottom / 1000 * 1440)
      ELSIF BAND(SELF.PageSetupDialog.Flags, PSD_INHUNDREDTHSOFMILLIMETERS)
        SELF.FormatRange.rc.left   += (SELF.PageSetupDialog.rtMargin.left   / 2540 * 1440)
        SELF.FormatRange.rc.top    += (SELF.PageSetupDialog.rtMargin.top    / 2540 * 1440)
        SELF.FormatRange.rc.right  -= (SELF.PageSetupDialog.rtMargin.right  / 2540 * 1440)
        SELF.FormatRange.rc.bottom -= (SELF.PageSetupDialog.rtMargin.bottom / 2540 * 1440)
      END
      SELF.FormatRange.rcPage    :=: SELF.FormatRange.rc
      SELF.FormatRange.chrg.cpMax =  0
      SELF.FormatRange.chrg.cpMax = -1

         ! --- Select text to print
      WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))   ! Store old CharRange
      WM = SendMessage(SELF.RTFhwnd, EM_SETSEL, 0, -1)                          ! Select all text from end to start
      WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(CharRange))        ! Get position of text-end
      WM = SendMessage(SELF.RTFhwnd, EM_EXSETSEL, 0, ADDRESS(SELF.CharRange))   ! Restore old CharRange
      MaxChar = CharRange.cpMax
      OutChar = 0

        ! --- Ensure printer PrintDlg.hDC is in text map mode
      OldMap = SetMapMode(SELF.PrintDialog.hDC, MM_TEXT)

        ! --- Start printer
      CLEAR(DocInfo)
      DocName = '(RTF Document v2.0) - ' & SELF.StripFileName
      DocInfo.cbSize      = SIZE(DocInfo)
      DocInfo.lpszDocName = ADDRESS(DocName)
      DocInfo.lpszOutput  = 0 ! NULL
      ASSERT(StartDoc(SELF.PrintDialog.hDc, DocInfo) > 0)
      ASSERT(SendMessage(SELF.RTFhwnd, EM_FORMATRANGE, TRUE, 0))   ! Flush Buffer
      LOOP
        ASSERT(StartPage(SELF.PrintDialog.hDC))
        SELF.FormatRange.chrg.cpMin = OutChar
        IF TRUE
          ! -- Use Display Band --
          OutChar = SendMessage(SELF.RTFhwnd, EM_FORMATRANGE, FALSE, ADDRESS(SELF.FormatRange))
          ASSERT(SendMessage(SELF.RTFhwnd, EM_DISPLAYBAND, FALSE, ADDRESS(SELF.FormatRange.rc)))
        ELSE
          ! -- Use Format Range --
          OutChar = SendMessage(SELF.RTFhwnd, EM_FORMATRANGE, TRUE, ADDRESS(SELF.FormatRange))
        END
        ASSERT(EndPage(SELF.PrintDialog.hDC))
      UNTIL OutChar >= MaxChar OR OutChar = -1
      ASSERT(SendMessage(SELF.RTFhwnd, EM_FORMATRANGE, TRUE, 0))   ! Flush Buffer
      ASSERT(EndDoc(SELF.PrintDialog.hDC))

      ASSERT(SetMapMode(SELF.PrintDialog.hDC, OldMap))

      IF NOT SELF.MailFileOpen                      ! Don't delete hDC if Mail File is open. The hDC is closed when the
        ASSERT(DeleteDC(SELF.PrintDialog.hDC))      ! Mail File is closed.
      END

    END
  ELSE
    BEEP(SELF.Setup.WarningSound)
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Format the document to the printer
!|
LocRichEditClass.FormatDoc          PROCEDURE()

PageWidth       LONG
hDC             LONG
lpszDriver      CSTRING(32)
lpszDevice      CSTRING(32)
lpszOutput      CSTRING(32)
LogX            LONG
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.Setup.HScroll AND SELF.Setup.WordWrap

    IF SELF.Setup.FirstTimeFormat
      SELF.Setup.FirstTimeFormat = FALSE
      lpszDriver = ''
      lpszDevice = PRINTER{PROPPRINT:Device}
      lpszOutput = ''
      hDC = CreateDC(lpszDriver, lpszDevice, lpszOutput, SELF.PageSetupDialog.hDevMode)
    ELSE
      CLEAR(SELF.PrintDialog)
      SELF.PrintDialog.lStructSize = SIZE(SELF.PrintDialog)
      SELF.PrintDialog.hwndOwner   = SELF.RTFhwnd
      SELF.PrintDialog.hDevMode    = SELF.PageSetupDialog.hDevMode
      SELF.PrintDialog.Flags       = PD_RETURNDC + PD_PRINTSETUP
      WM = PrintDlg(SELF.PrintDialog)
      hDC = SELF.PrintDialog.hDC
      SELF.PageSetupDialog.hDevMode = SELF.PrintDialog.hDevMode
    END

    IF hDC

      LogX       = GetDeviceCaps(hDC, LOGPIXELSX)
      PageWidth  = GetDeviceCaps(hDC, HORZRES)

      CLEAR(SELF.FormatRange)
      SELF.FormatRange.rc.top     =  0
      SELF.FormatRange.rc.left    =  0
      SELF.FormatRange.rc.right   =  (PageWidth  / LogX) * 1440

      ! --- Set page margins
      IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
        SELF.FormatRange.rc.top    += (SELF.PageSetupDialog.rtMargin.top    / 1000 * 1440)
        SELF.FormatRange.rc.left   += (SELF.PageSetupDialog.rtMargin.left   / 1000 * 1440)
        SELF.FormatRange.rc.right  -= (SELF.PageSetupDialog.rtMargin.right  / 1000 * 1440)
      ELSIF BAND(SELF.PageSetupDialog.Flags, PSD_INHUNDREDTHSOFMILLIMETERS)
        SELF.FormatRange.rc.top    += (SELF.PageSetupDialog.rtMargin.top    / 2540 * 1440)
        SELF.FormatRange.rc.left   += (SELF.PageSetupDialog.rtMargin.left   / 2540 * 1440)
        SELF.FormatRange.rc.right  -= (SELF.PageSetupDialog.rtMargin.right  / 2540 * 1440)
      END

      ASSERT(SendMessage(SELF.RTFhwnd, EM_SETTARGETDEVICE, hDC, SELF.FormatRange.rc.right - SELF.FormatRange.rc.left))
      ASSERT(DeleteDC(hDC))

      SELF.Setup.TabRulerWidth = (SELF.FormatRange.rc.right - SELF.FormatRange.rc.left) / 1440 * SELF.Setup.LogX
      IF SELF.Setup.TabRulerWidth > SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin
        SELF.Setup.TabRulerWidth = SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin
      END

      SELF.UpdateRuler

    END

  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open page setup-dialog and sets the page setup.
!|
LocRichEditClass.PageSetup          PROCEDURE()

OldSetup        LIKE(_PAGESETUPDLG)

  CODE

  ASSERT(SELF.RTFhwnd)

  OldSetup :=: SELF.PageSetupDialog

  SELF.PageSetupDialog.Flags    = PSD_MARGINS + PSD_MINMARGINS
  IF NOT PageSetupDlg(SELF.PageSetupDialog)
    SELF.PageSetupDialog :=: OldSetup
  END

  SELF.FormatDoc
  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open font-dialog and sets the character font.
!|
LocRichEditClass.Font               PROCEDURE()

Face_old        CSTRING(33)
Size_old        CSTRING(10)
Color_old       CSTRING(10)
Bold_old        LONG
Italic_old      LONG
Underline_old   LONG
Strikeout_old   LONG

Face_new        CSTRING(33)
Size_new        CSTRING(10)
Color_new       CSTRING(10)
Style           CSTRING(10)

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.CharFormat.dwMask = CFM_FACE + CFM_SIZE + CFM_COLOR + CFM_BOLD + CFM_ITALIC + CFM_UNDERLINE + CFM_STRIKEOUT
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))

  Face_old      = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_FACE) <> 0, SELF.CharFormat.szFaceName, '')
  Size_old      = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_SIZE) <> 0, SELF.CharFormat.yHeight / 20, '')
  Color_old     = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_COLOR) <> 0, SELF.CharFormat.crTextColor, '')
  Bold_old      = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_BOLD) <> 0, BAND(SELF.CharFormat.dwEffects, CFE_BOLD), 0)
  Italic_old    = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_ITALIC) <> 0, BAND(SELF.CharFormat.dwEffects, CFE_ITALIC), 0)
  Underline_old = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_UNDERLINE) <> 0, BAND(SELF.CharFormat.dwEffects, CFE_UNDERLINE), 0)
  Strikeout_old = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_STRIKEOUT) <> 0, BAND(SELF.CharFormat.dwEffects, CFE_STRIKEOUT), 0)

  Face_new = Face_old
  Size_new = Size_old
  Color_new = Color_old

  IF BAND(SELF.CharFormat.dwMask, CFM_BOLD) AND BAND(SELF.CharFormat.dwMask, CFM_ITALIC) THEN Style = FONT:Regular ELSE Style = ''.
  IF Bold_old      THEN Style += FONT:Bold.
  IF Italic_old    THEN Style += FONT:Italic.
  IF Underline_old THEN Style += FONT:Underline.
  IF Strikeout_old THEN Style += FONT:Strikeout.

  IF FONTDIALOG(, Face_new, Size_new, Color_new, Style)
    ! --- Set mask ---
    SELF.CharFormat.dwMask = 0
    IF Face_new  <> Face_old                    THEN SELF.CharFormat.dwMask += CFM_FACE.
    IF Size_new  <> Size_old                    THEN SELF.CharFormat.dwMask += CFM_SIZE.
    IF Color_new <> Color_old                   THEN SELF.CharFormat.dwMask += CFM_COLOR.
    IF BAND(Style, FONT:Weight) = FONT:Bold     THEN SELF.CharFormat.dwMask += CFM_BOLD.
    IF BAND(Style, FONT:Italic)                 THEN SELF.CharFormat.dwMask += CFM_ITALIC.
    IF BAND(Style, FONT:Underline)              THEN SELF.CharFormat.dwMask += CFM_UNDERLINE.
    IF BAND(Style, FONT:Strikeout)              THEN SELF.CharFormat.dwMask += CFM_STRIKEOUT.
    ! --- Set Face, Size and Color ---
    SELF.CharFormat.dwEffects = BXOR(BOR(SELF.CharFormat.dwEffects, CFE_BOLD + CFE_ITALIC + CFE_UNDERLINE + CFE_STRIKEOUT), CFE_BOLD + CFE_ITALIC + CFE_UNDERLINE + CFE_STRIKEOUT)
    IF Face_new <> Face_old                     THEN SELF.CharFormat.szFaceName = Face_new.
    IF Size_new <> Size_old                     THEN SELF.CharFormat.yHeight = Size_new * 20.
    IF Color_new <> Color_old                   THEN SELF.CharFormat.crTextColor = Color_new.
    ! --- Set Effects ---
    IF BAND(Style, FONT:Weight) = FONT:Bold     THEN SELF.CharFormat.dwEffects += CFE_BOLD.
    IF BAND(Style, FONT:Italic)                 THEN SELF.CharFormat.dwEffects += CFE_ITALIC.
    IF BAND(Style, FONT:Underline)              THEN SELF.CharFormat.dwEffects += CFE_UNDERLINE.
    IF BAND(Style, FONT:Strikeout)              THEN SELF.CharFormat.dwEffects += CFE_STRIKEOUT.
    ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open color-dialog and sets the text color.
!|
LocRichEditClass.Color              PROCEDURE()

Color_old       CSTRING(10)
Color_new       CSTRING(10)

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.CharFormat.dwMask = CFM_COLOR
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))
  Color_old = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_COLOR) <> 0, SELF.CharFormat.crTextColor, '')
  Color_new = Color_old
  IF COLORDIALOG(, Color_new) AND Color_new <> Color_old
    SELF.CharFormat.dwMask = CFM_COLOR
    SELF.CharFormat.crTextColor = Color_new
    ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open color-dialog and sets the background color.
!|
LocRichEditClass.BackColor          PROCEDURE()

Color_old       CSTRING(10)
Color_new       CSTRING(10)

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.CharFormat.dwMask = CFM_BACKCOLOR
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))
  Color_old = CHOOSE(BAND(SELF.CharFormat.dwMask, CFM_BACKCOLOR) <> 0, SELF.CharFormat.crBackColor, '')
  Color_new = Color_old
  IF COLORDIALOG(, Color_new) AND Color_new <> Color_old
    SELF.CharFormat.dwMask = CFM_BACKCOLOR
    SELF.CharFormat.crBackColor = Color_new
    ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open paragraph-dialog and sets paragraph values.
!|
LocRichEditClass.Paragraph          PROCEDURE()

Left_new        CSTRING(10)
Right_new       CSTRING(10)
OffSet_new      CSTRING(10)
Before_new      CSTRING(10)
After_new       CSTRING(10)
Spacing_new     CSTRING(10)
LineSpacing_new CSTRING(25)
Alignment_new   CSTRING(25)

Left_old        CSTRING(10)
Right_old       CSTRING(10)
OffSet_old      CSTRING(10)
Before_old      CSTRING(10)
After_old       CSTRING(10)
Spacing_old     CSTRING(10)
LineSpacing_old CSTRING(25)
Alignment_old   CSTRING(25)

WM              LONG

ParaWindow      WINDOW('Paragraph Setup'),AT(,,268,97),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
                  GROUP('Indent'),AT(5,5,121,56),BOXED
                    PROMPT('&Left:'),AT(13,18)
                    SPIN(@s5),AT(63,18,44,10),USE(Left_new),RIGHT(2),RANGE(0,99.99),STEP(0.5)
                    STRING('cm'),AT(109,18),USE(?LeftStr)
                    PROMPT('&Right:'),AT(13,32)
                    SPIN(@s5),AT(63,32,44,10),USE(Right_new),RIGHT(2),RANGE(0,99.99),STEP(0.5)
                    STRING('cm'),AT(109,32),USE(?RightStr)
                    PROMPT('&First line offset:'),AT(13,46)
                    SPIN(@s6),AT(63,46,44,10),USE(Offset_new),RIGHT(2),RANGE(-99.99,99.99),STEP(0.5)
                    STRING('cm'),AT(109,46),USE(?OffsetStr)
                  END
                  GROUP('Spacing'),AT(130,5,132,70),BOXED
                    PROMPT('A&bove paragraph:'),AT(137,18)
                    SPIN(@S5),AT(197,18,44,10),USE(Before_new),RIGHT(2),RANGE(0, 100),STEP(6)
                    PROMPT('B&elow paragraph:'),AT(137,32)
                    SPIN(@S5),AT(197,32,44,10),USE(After_new),RIGHT(2),RANGE(0, 100),STEP(6)
                    PROMPT('Fi&xed line spacing:'),AT(137,46)
                    LIST,AT(197,46,61,10),USE(LineSpacing_new),LEFT(2),DROP(10),FROM('Single|One-and-a-half|Double|Variable space')
                    PROMPT('Bet&ween lines:'),AT(137,60), USE(?PromptSpacing)
                    SPIN(@S5),AT(197,60,44,10),USE(Spacing_new),RIGHT(2),RANGE(0, 100),STEP(1)
                  END
                  GROUP,AT(5,65,121,27),BOXED
                    PROMPT('&Alignment:'),AT(13,79)
                    LIST,AT(63,79,58,10),USE(Alignment_new),LEFT(2),DROP(10),FROM('Left|Right|Center')
                  END
                  BUTTON('Cancel'),AT(130,78,55,14),USE(?ButtonCancel)
                  BUTTON('Ok'),AT(207,78,55,14),USE(?ButtonOk),DEFAULT
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SYSTEM{PROP:Icon} = '~RichEdit.ico'
  OPEN(ParaWindow)
  SYSTEM{PROP:Icon} = SELF.Setup.SystemIcon

  IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
    ?LeftStr{PROP:Text}    = 'inch'
    ?RightStr{PROP:Text}   = 'inch'
    ?OffSetStr{PROP:Text}  = 'inch'
    ?Left_new{PROP:Step}   = 0.2
    ?Right_new{PROP:Step}  = 0.2
    ?Offset_new{PROP:Step} = 0.2
  END

  SELF.ParaFormat.dwMask = PFM_STARTINDENT + PFM_RIGHTINDENT + PFM_OFFSET + PFM_ALIGNMENT + PFM_SPACEAFTER + PFM_SPACEBEFORE + PFM_LINESPACING
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))

  Left_new =    CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_STARTINDENT) = 0, '', INT((SELF.ParaFormat.dxStartIndent + SELF.ParaFormat.dxOffset) / SELF.Setup.Algorithm * 100 + 0.5) / 100)
  Right_new =   CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_RIGHTINDENT) = 0, '', INT(SELF.ParaFormat.dxRightIndent / SELF.Setup.Algorithm * 100 + 0.5) / 100)
  Offset_new =  CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_OFFSETINDENT) = 0, '', INT(-SELF.ParaFormat.dxOffset / SELF.Setup.Algorithm * 100 + 0.5) / 100)
  Before_new =  CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_SPACEBEFORE) = 0, '', INT(SELF.ParaFormat.dySpaceBefore / 20 * 100 + 0.5) / 100)
  After_new =   CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_SPACEAFTER) = 0, '', INT(SELF.ParaFormat.dySpaceAfter / 20 * 100 + 0.5) / 100)
  Spacing_new = CHOOSE(BAND(SELF.ParaFormat.dwMask, PFM_LINESPACING) = 0, '', INT((SELF.ParaFormat.dyLineSpacing - 10) / 2 * 100 + 0.5) / 100)

  IF Spacing_new < 0
    Spacing_new = 5
  END

  IF BAND(SELF.ParaFormat.dwMask, PFM_LINESPACING)
    ?LineSpacing_new{PROP:Selected} = SELF.ParaFormat.bLineSpacingRule + 1
    IF SELF.ParaFormat.bLineSpacingRule = 5
      ?LineSpacing_new{PROP:Selected} = 4
    END
  ELSE
    ?LineSpacing_new{PROP:ScreenText} = ''
  END

  IF BAND(SELF.ParaFormat.dwMask, PFM_ALIGNMENT)
    ?Alignment_new{PROP:Selected} = SELF.ParaFormat.wAlignment
  ELSE
    ?Alignment_new{PROP:ScreenText} = ''
  END

  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_STARTINDENT) THEN Left_new = ''.
  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_RIGHTINDENT) THEN Right_new = ''.
  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_OFFSET) THEN Offset_new = ''.
  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_SPACEAFTER) THEN After_new = ''.
  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_SPACEBEFORE) THEN Before_new = ''.
  IF NOT BAND(SELF.ParaFormat.dwMask, PFM_LINESPACING) THEN Spacing_new = ''.

  Left_old        = Left_new
  Right_old       = Right_new
  Offset_old      = Offset_new
  Before_old      = Before_new
  After_old       = After_new
  Spacing_old     = Spacing_new
  LineSpacing_old = LineSpacing_new
  Alignment_old   = Alignment_new

  ?Right_new{PROP:ScreenText} = ''

  ACCEPT
    IF CHOICE(?LineSpacing_new) = 4
      ENABLE(?PromptSpacing, ?Spacing_new)
    ELSE
      DISABLE(?PromptSpacing, ?Spacing_new)
    END
    CASE ACCEPTED()
    OF ?ButtonOk
      ! --- Set Mask ---
      SELF.ParaFormat.dwMask = 0
      IF Offset_new <> Offset_old       THEN SELF.ParaFormat.dwMask = PFM_OFFSET + PFM_STARTINDENT; ELSIF Left_new <> Left_old THEN        SELF.ParaFormat.dwMask += PFM_STARTINDENT.
      IF Right_new <> Right_old         THEN SELF.ParaFormat.dwMask += PFM_RIGHTINDENT.
      IF Before_new <> Before_old       THEN SELF.ParaFormat.dwMask += PFM_SPACEBEFORE.
      IF After_new <> After_old         THEN SELF.ParaFormat.dwMask += PFM_SPACEAFTER.
      IF Spacing_new <> Spacing_old OR LineSpacing_new <> LineSpacing_old THEN SELF.ParaFormat.dwMask += PFM_LINESPACING.
      IF Alignment_new <> Alignment_old THEN SELF.ParaFormat.dwMask += PFM_ALIGNMENT.
      ! --- Set ParaFormat ---
      IF SELF.ParaFormat.dwMask
        SELF.ParaFormat.dxStartIndent = (Left_new + Offset_new) * SELF.Setup.Algorithm
        SELF.ParaFormat.dxRightIndent = Right_new * SELF.Setup.Algorithm
        SELF.ParaFormat.dxOffset      = -Offset_new * SELF.Setup.Algorithm
        SELF.ParaFormat.dySpaceBefore = Before_new * 20
        SELF.ParaFormat.dySpaceAfter  = After_new * 20
        IF CHOICE(?LineSpacing_new) < 4
          SELF.ParaFormat.bLineSpacingRule = CHOICE(?LineSpacing_new) - 1
        ELSE
          SELF.ParaFormat.dyLineSpacing = Spacing_new * 2 + 10
          SELF.ParaFormat.bLineSpacingRule = 5
        END
        SELF.ParaFormat.wAlignment    = CHOICE(?Alignment_new)
        WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))
      END
      POST(EVENT:CloseWindow)
    OF ?ButtonCancel
      POST(EVENT:CloseWindow)
    END
  END

  CLOSE(ParaWindow)

  SELF.UpdateWindow

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open tabulator stops-dialog and sets tabulator stops.
!|
LocRichEditClass.TabStops           PROCEDURE()

EntryTabStop    SREAL
TabNo           LONG
QueueTabStops   QUEUE
TabValue          SREAL
Measurement       STRING('cm  ')
                END
OldParaFormat   LIKE(_PARAFORMAT2)
WM              LONG

TabStopsWindow WINDOW('Tabulator Stops Setup'),AT(,,180,120),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
                  PROMPT('&Set tabulator:'),AT(7,12)
                  ENTRY(@N5.`2),AT(56,13,65,10),USE(EntryTabStop),IMM,RIGHT(2)
                  PROMPT('&Tabulator list:'),AT(8,28)
                  LIST,AT(56,27,65,85),USE(?ListTabStops),VSCROLL,FORMAT('35R@N6.`2@20R(2)'),FROM(QueueTabStops)
                  BUTTON('Delete All'),AT(128,13,45,14),USE(?ButtonDeleteAll)
                  BUTTON('Delete'),AT(128,30,45,14),USE(?ButtonDelete)
                  BUTTON('Add'),AT(128,47,45,14),USE(?ButtonAdd),DEFAULT
                  BUTTON('Apply'),AT(128,64,45,14),USE(?ButtonApply)
                  BUTTON('Cancel'),AT(128,81,45,14),USE(?ButtonCancel)
                  BUTTON('Ok'),AT(128,98,45,14),USE(?ButtonOk)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.ParaFormat.dwMask = PFM_TABSTOPS
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))

  OldParaFormat :=: SELF.ParaFormat

  SYSTEM{PROP:Icon} = '~RichEdit.ico'
  OPEN(TabStopsWindow)
  SYSTEM{PROP:Icon} = SELF.Setup.SystemIcon

  IF BAND(SELF.PageSetupDialog.Flags, PSD_INTHOUSANDTHSOFINCHES)
    QueueTabStops.Measurement  = 'inch'
    ?EntryTabStop{PROP:Text}   = '@N5.2'
    ?ListTabStops{PROP:Format} = '35R@N6.`2@20R(2)'
  END

  LOOP TabNo = 1 TO MAX_TAB_STOPS
    IF SELF.ParaFormat.rgxTabs[TabNo] > 0
      QueueTabStops.TabValue = SELF.ParaFormat.rgxTabs[TabNo] / SELF.Setup.Algorithm
      ADD(QueueTabStops, QueueTabStops.TabValue)
    END
  END

  ?ListTabStops{PROP:Selected} = 1

  ACCEPT
    IF EVENT() = EVENT:NewSelection AND FIELD() = ?ListTabStops
      GET(QueueTabStops, CHOICE(?ListTabStops))
      EntryTabStop = QueueTabStops.TabValue
      SELECT(?EntryTabStop)
    END
    CASE ACCEPTED()
    OF ?ButtonDeleteAll
      FREE(QueueTabStops)
      CLEAR(EntryTabStop)
      SELECT(?EntryTabStop)
    OF ?ButtonDelete
      DELETE(QueueTabStops)
      GET(QueueTabStops, CHOICE(?ListTabStops))
      EntryTabStop = QueueTabStops.TabValue
      SELECT(?EntryTabStop)
    OF ?ButtonAdd
      IF EntryTabStop > 0
        QueueTabStops.TabValue = EntryTabStop
        GET(QueueTabStops, QueueTabStops.TabValue)
        IF ERRORCODE()
          ADD(QueueTabStops, QueueTabStops.TabValue)
          ?ListTabStops{PROP:Selected} = POINTER(QueueTabStops)
        END
      ELSE
        BEEP(SELF.Setup.WarningSound)
      END
      CLEAR(EntryTabStop)
      SELECT(?EntryTabStop)
    OF ?ButtonApply
      SETTARGET(SELF.ParentWindow)
      DO UpdateTabs
      SELF.UpdateTabulator
      SETTARGET(TabStopsWindow)
      SELECT(?EntryTabStop)
    OF ?ButtonCancel
      SELF.ParaFormat :=: OldParaFormat
      WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))
      WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, SELF.Info.Modified, 0)
      POST(EVENT:CloseWindow)
    OF ?ButtonOk
      DO UpdateTabs
      POST(EVENT:CloseWindow)
    END
    UPDATE
    IF RECORDS(QueueTabStops) THEN ?ButtonDeleteAll{PROP:Disable} = FALSE ELSE ?ButtonDeleteAll{PROP:Disable} = TRUE.
    IF CHOICE(?ListTabStops)  THEN ?ButtonDelete{PROP:Disable} = FALSE ELSE ?ButtonDelete{PROP:Disable} = TRUE.
    IF EntryTabStop > 0       THEN ?ButtonAdd{PROP:Disable} = FALSE ELSE ?ButtonAdd{PROP:Disable} = TRUE.
    IF RECORDS(QueueTabstops) >= MAX_TAB_STOPS THEN ?ButtonAdd{PROP:Disable} = TRUE ELSE ?ButtonAdd{PROP:Disable} = FALSE.
  END

  CLOSE(TabStopsWindow)

  SELF.SetFocus

UpdateTabs      ROUTINE

  CLEAR(SELF.ParaFormat.rgxTabs)
  LOOP TabNo = 1 TO RECORDS(QueueTabStops)
    GET(QueueTabStops, TabNo)
    SELF.ParaFormat.rgxTabs[TabNo] = INT(QueueTabStops.TabValue * SELF.Setup.Algorithm)
  END
  SELF.ParaFormat.cTabcount = RECORDS(QueueTabStops)
  WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Grapping an indent mark.
!|
LocRichEditClass.GrapIndent         PROCEDURE()

CtrlEquate      LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.DraggingIndent = FALSE

  LOOP CtrlEquate = SELF.Setup.Indent TO SELF.Setup.Indent + 2
    IF INRANGE(MOUSEX(), CtrlEquate{PROP:XPos}, CtrlEquate{PROP:XPos} + CtrlEquate{PROP:Width}) AND INRANGE(MOUSEY(), CtrlEquate{PROP:YPos}, CtrlEquate{PROP:YPos} + CtrlEquate{PROP:Height})
      SELF.DraggingIndent = CtrlEquate
      BREAK
    END
  END

  SELF.DistanceIndent = SELF.Setup.Indent{PROP:XPos} - (SELF.Setup.Indent+1){PROP:XPos}

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Dragging the indent mark.
!|
LocRichEditClass.DragIndent         PROCEDURE()

CtrlNo          LONG
MouseXPos       LONG
MaxWidth        LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.DraggingIndent

    SELF.Setup.DummyXPos{PROP:XPos} = MOUSEX() ! Convert MOUSEX() to pixel
    SELF.ParentWindow{PROP:Pixels} = TRUE
    MouseXPos = SELF.Setup.DummyXPos{PROP:XPos}

    IF SELF.Setup.TabRegionWidth < SELF.Setup.TabRulerWidth
      MaxWidth = SELF.Setup.TabRegionWidth - SELF.Setup.LeftMargin - SELF.Setup.RightMargin
    ELSE
      MaxWidth = SELF.Setup.TabRulerWidth
    END
    IF INRANGE(MouseXPos, SELF.Setup.TabRulerXPos + SELF.Setup.Indent{PROP:Width} / 2, SELF.Setup.TabRulerXPos + MaxWidth - SELF.Setup.Indent{PROP:Width} / 2)
      SELF.DraggingIndent{PROP:XPos} = MouseXPos - SELF.DraggingIndent{PROP:Width} / 2
      IF SELF.DraggingIndent - 1 = SELF.Setup.Indent
        (SELF.DraggingIndent - 1){PROP:XPos} = SELF.DraggingIndent{PROP:XPos} + SELF.DistanceIndent
      END
      LOOP CtrlNo = SELF.Setup.Indent TO SELF.Setup.Indent + 1
        IF INRANGE(CtrlNo{PROP:XPos}, SELF.Setup.TabRegionXPos, SELF.Setup.TabRegionXPos + SELF.Setup.TabRegionWidth - CtrlNo{PROP:Width})
          UNHIDE(CtrlNo)
        ELSE
          HIDE(CtrlNo)
        END
      END
    END

    CASE SELF.DraggingIndent
    OF SELF.Setup.Indent OROF SELF.Setup.Indent + 1
      SELF.ParaFormat.dxOffset      = -(SELF.Setup.Indent{PROP:XPos} - (SELF.Setup.Indent+1){PROP:XPos}) * 1440 / SELF.Setup.LogX
      SELF.ParaFormat.dxStartIndent = ((SELF.Setup.Indent+1){PROP:XPos} - SELF.Setup.TabRulerXPos) * 1440 / SELF.Setup.LogX - SELF.ParaFormat.dxOffset
    OF SELF.Setup.Indent + 2
      SELF.ParaFormat.dxRightIndent = (SELF.Setup.TabRulerWidth - (SELF.Setup.Indent+2){PROP:Width} - (SELF.Setup.Indent+2){PROP:XPos} + SELF.Setup.TabRulerXPos) * 1440 / SELF.Setup.LogX
    END

    SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState

  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Dropping the indent mark.
!|
LocRichEditClass.DropIndent         PROCEDURE()

WM          LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.DraggingIndent = FALSE

  SELF.ParaFormat.dwMask = PFM_STARTINDENT + PFM_OFFSET + PFM_RIGHTINDENT
  WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Justify Left or Offset Indent
!|
LocRichEditClass.JustifyIndent      PROCEDURE()

CtrlEquate      LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  LOOP CtrlEquate = SELF.Setup.Indent TO SELF.Setup.Indent + 1
    IF INRANGE(MOUSEX(), CtrlEquate{PROP:XPos}, CtrlEquate{PROP:XPos} + CtrlEquate{PROP:Width}) AND INRANGE(MOUSEY(), CtrlEquate{PROP:YPos}, CtrlEquate{PROP:YPos} + CtrlEquate{PROP:Height})
      SELF.DraggingIndent = CtrlEquate
      CASE CtrlEquate
      OF SELF.Setup.Indent
        (SELF.Setup.Indent + 1){PROP:XPos} = CtrlEquate{PROP:XPos}
      OF SELF.Setup.Indent + 1
        SELF.Setup.Indent{PROP:XPos} = CtrlEquate{PROP:XPos}
      END
      SELF.DistanceIndent = 0
      SELF.DragIndent
      BREAK
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Copy the selection into the clipboard.
!|
LocRichEditClass.Copy               PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, WM_COPY, 0, 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Cuts the selection into the clipboard.
!|
LocRichEditClass.Cut                PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, WM_CUT, 0, 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Past the clipboard into the selected text.
!|
LocRichEditClass.Paste              PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, WM_PASTE, 0, 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Turns tabstop on and off
!|
LocRichEditClass.ToggleTabstop      PROCEDURE()

TabPos          LONG
TabNo           LONG
DelNo           LONG
WM              LONG
MousePos        LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.DraggingIndent
    SELF.DropIndent
    RETURN
  END

  ! --- Change to MouseXPos to Pixels ---
  SELF.Setup.DummyXPos{PROP:Xpos} = MOUSEX()
  SELF.ParentWindow{PROP:Pixels} = TRUE
  MousePos = SELF.Setup.DummyXPos{PROP:XPos} - SELF.Setup.TabRulerXPos
  SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState

  IF INRANGE(MousePos, 0, SELF.Setup.TabRulerWidth)

    SELF.ParaFormat.dwMask = PFM_TABSTOPS
    ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))

    TabPos = INT(MousePos * 1440 / SELF.Setup.LogX / 100) * 100
    LOOP TabNo = 1 TO MAX_TAB_STOPS
      IF INRANGE(SELF.ParaFormat.rgxTabs[TabNo], TabPos - 50, TabPos + 50)
        LOOP DelNo = TabNo TO MAX_TAB_STOPS - 1
          SELF.ParaFormat.rgxTabs[DelNo] = SELF.ParaFormat.rgxTabs[DelNo + 1]
        END
        SELF.ParaFormat.rgxTabs[DelNo] = 0
        SELF.ParaFormat.cTabcount -= 1
        BREAK
      ELSIF (SELF.ParaFormat.rgxTabs[TabNo] > TabPos OR SELF.ParaFormat.rgxTabs[TabNo] = 0) AND SELF.ParaFormat.cTabcount < MAX_TAB_STOPS
        LOOP DelNo = MAX_TAB_STOPS TO TabNo + 1 BY -1
          SELF.ParaFormat.rgxtabs[DelNo] = SELF.ParaFormat.rgxTabs[DelNo - 1]
        END
        SELF.ParaFormat.rgxTabs[TabNo] = TabPos
        SELF.ParaFormat.cTabcount += 1
        BREAK
      END
    END
    WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

    SELF.UpdateWindow

  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Turn the selected FontStyle on and off for the selected text.
!| FontStyle:   FONT:Regular, FONT:Bold, FONT:Italic, FONT:Underline, FONT:Strikeout or FONT:Fixed
!|
LocRichEditClass.ToggleFontStyle    PROCEDURE(LONG FontStyle)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  CASE FontStyle
  OF FONT:Regular
    SELF.CharFormat.dwMask = CFM_BOLD + CFM_ITALIC + CFM_UNDERLINE + CFM_STRIKEOUT
  OF FONT:Bold
    SELF.CharFormat.dwMask = CFM_BOLD
  OF FONT:Italic
    SELF.CharFormat.dwMask = CFM_ITALIC
  OF FONT:Underline
    SELF.CharFormat.dwMask = CFM_UNDERLINE
  OF FONT:Strikeout
    SELF.CharFormat.dwMask = CFM_STRIKEOUT
  OF FONT:Fixed
    SELF.CharFormat.dwMask = CFM_PROTECTED
  END
  WM = SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat))

  CASE FontStyle
  OF FONT:Regular
    SELF.CharFormat.dwEffects = 0
    SELF.CharFormat.dwMask    = CFM_BOLD + CFM_ITALIC + CFM_UNDERLINE + CFM_STRIKEOUT
  OF FONT:Bold
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_BOLD)
    SELF.CharFormat.dwMask    = CFM_BOLD
  OF FONT:Italic
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_ITALIC)
    SELF.CharFormat.dwMask    = CFM_ITALIC
  OF FONT:Underline
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_UNDERLINE)
    SELF.CharFormat.dwMask    = CFM_UNDERLINE
  OF FONT:Strikeout
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_STRIKEOUT)
    SELF.CharFormat.dwMask    = CFM_STRIKEOUT
  OF FONT:Fixed
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_PROTECTED)
    SELF.CharFormat.dwMask    = CFM_PROTECTED
  END
  WM = SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat))

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Alignment of the pressent paragraph.
!|  Alignment:  1 - Left alignment, 2 - Center alignment, 3 - Right alignment
!|
LocRichEditClass.ToggleAlignment    PROCEDURE(BYTE Alignment)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  CASE Alignment
  OF 1
    SELF.ParaFormat.wAlignment = PFA_LEFT
  OF 2
    SELF.ParaFormat.wAlignment = PFA_CENTER
  OF 3
    SELF.ParaFormat.wAlignment = PFA_RIGHT
  END

  SELF.ParaFormat.dwMask = PFM_ALIGNMENT
  WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Turn bullets on and of for the present paragraph.
!|  Indent:     Sets the indent for the bullet line. (Try to use 15)
!|
LocRichEditClass.ToggleBullet       PROCEDURE(SHORT Indent)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.ParaFormat.dwMask = PFM_NUMBERING + PFM_OFFSET
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))

  SELF.ParaFormat.wNumbering = BXOR(SELF.ParaFormat.wNumbering, PFN_BULLET)

  IF SELF.ParaFormat.wNumbering = PFN_BULLET
    SELF.ParaFormat.dxOffset = Indent * 20
  ELSE
    SELF.ParaFormat.dxOffset = 0
  END

  SELF.ParaFormat.dwMask = PFM_NUMBERING + PFM_OFFSET
  WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Change Line Spacing
!|  LineSpace:  0 - Single, 1 - One-and-a-half, 2 - Double
!|
LocRichEditClass.ToggleLineSpace    PROCEDURE(BYTE LineSpace)

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF INLIST(LineSpace, 0, 1, 2)
    SELF.ParaFormat.bLineSpacingRule = LineSpace
    SELF.ParaFormat.dwMask = PFM_LINESPACING
    WM = SendMessage(SELF.RTFhwnd, EM_SETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat))
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Set the vertical offset of characters.
!|  SubSuper:   +1 = Superscript, -1 = Subscript
!|
LocRichEditClass.ToggleSubSuperScript   PROCEDURE(SHORT SubSuper)

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.CharFormat.dwMask = CFM_SUBSCRIPT
  ASSERT(SendMessage(SELF.RTFHwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))
  IF SubSuper > 0
    IF BAND(SELF.CharFormat.dwEffects, CFE_SUBSCRIPT)
      SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_SUBSCRIPT)
    END
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_SUPERSCRIPT)
  ELSIF SubSuper < 0
    IF BAND(SELF.CharFormat.dwEffects, CFE_SUPERSCRIPT)
      SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_SUPERSCRIPT)
    END
    SELF.CharFormat.dwEffects = BXOR(SELF.CharFormat.dwEffects, CFE_SUBSCRIPT)
  END
  SELF.CharFormat.dwMask = CFM_SUBSCRIPT
  ASSERT(SendMessage(SELF.RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, ADDRESS(SELF.CharFormat)))

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Undo the last operation
!|
LocRichEditClass.Undo               PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, EM_UNDO, 0, 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Redo the last Undo operation
!|
LocRichEditClass.Redo               PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, EM_REDO, 0, 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open a Find Text dialog
!|  FindNext:   If TRUE then find the next occurrence of text; if FALSE open find text dialog
!|
LocRichEditClass.FindText           PROCEDURE(BYTE FindNext=FALSE)

WM              LONG
Flags           LONG,STATIC
SearchString    CSTRING(256),STATIC
WholeWords      BOOL,STATIC
CaseSensitive   BOOL,STATIC

FindTextWindow  WINDOW('Find Text'),AT(,,236,62),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
                  PROMPT('Find &text:'),AT(5,8)
                  ENTRY(@s255),AT(43,6,137,11),USE(SearchString),LEFT(2)
                  CHECK(' &Whole words only'),AT(3,35),USE(WholeWords)
                  CHECK(' &Case sensitive search'),AT(3,49),USE(CaseSensitive)
                  BUTTON('&Find Next'),AT(184,5,48,14),USE(?ButtonFind),KEY(F3Key),DEFAULT
                  BUTTON('Cancel'),AT(184,24,48,14),USE(?ButtonCancel)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.Setup.PopupFindText = THREAD()

  IF SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
    IF FindNext AND SearchString
      DO FindNextText
    ELSE
      OPEN(FindTextWindow, SELF.ParentWindow)
      ACCEPT
        IF EVENT() = EVENT:Accepted
          CASE FIELD()
          OF ?ButtonFind
            Flags = FR_DOWN
            IF WholeWords
              Flags += FT_WHOLEWORD
            END
            IF CaseSensitive
              Flags += FT_MATCHCASE
            END
            DO FindNextText
          OF ?ButtonCancel
            POST(EVENT:CloseWindow)
          END
        END
      END
      CLOSE(FindTextWindow)
    END
  ELSE
    BEEP(SELF.Setup.WarningSound)
  END

  SELF.Setup.PopupFindText = FALSE

FindNextText    ROUTINE

  LOOP
    WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
    SELF.FindTextEx.lpstrText  = ADDRESS(SearchString)
    SELF.FindTextEx.chrg.cpMin = SELF.CharRange.cpMax
    SELF.FindTextEx.chrg.cpMax = SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
    WM = SendMessage(SELF.RTFhwnd, EM_FINDTEXTEX, Flags, ADDRESS(SELF.FindTextEx))
    IF WM > -1
      WM = SendMessage(SELF.RTFHwnd, EM_SETSEL, SELF.FindTextEx.chrgText.cpMin, SELF.FindTextEx.chrgText.cpMax)
    ELSE
      BEEP(SELF.Setup.WarningSound)
      IF MESSAGE('   "' & SearchString & '" not found.|   Continue from start of file?','Search',ICON:Question,BUTTON:Yes+BUTTON:No) = BUTTON:Yes
        WM = SendMessage(SELF.RTFhwnd, EM_SETSEL, 0, 0)
        CYCLE
      ELSE
        POST(EVENT:CloseWindow)
      END
    END
    BREAK
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open a Find and Replace Text dialog.
!|
LocRichEditClass.ReplaceText        PROCEDURE()

WM              LONG
Flags           LONG
SearchString    CSTRING(256),STATIC
ReplaceString   CSTRING(256),STATIC
WholeWords      BOOL,STATIC
CaseSensitive   BOOL,STATIC
FindTextWindow  WINDOW('Replace Text'),AT(,,236,74),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
                  PROMPT('Find &text:'),AT(5,8)
                  ENTRY(@s255),AT(52,6,128,12),USE(SearchString),LEFT(2)
                  PROMPT('R&eplace with:'),AT(5,24)
                  ENTRY(@s255),AT(52,23,128,12),USE(ReplaceString),LEFT(2)
                  CHECK(' &Whole words only'),AT(3,46),USE(WholeWords)
                  CHECK(' &Case sensitive search'),AT(3,60),USE(CaseSensitive)
                  BUTTON('&Find Next'),AT(184,5,48,14),USE(?ButtonFind),DEFAULT
                  BUTTON('&Replace'),AT(184,22,48,14),USE(?ButtonReplace),DISABLE
                  BUTTON('Replace &all'),AT(184,39,48,14),USE(?ButtonReplaceAll),DISABLE
                  BUTTON('Cancel'),AT(184,56,48,14),USE(?ButtonCancel)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.Setup.PopupReplaceText = THREAD()

  IF SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
    OPEN(FindTextWindow, SELF.ParentWindow)
    ACCEPT
      IF EVENT() = EVENT:Accepted
        CASE FIELD()
        OF ?ButtonFind
          Flags = FR_DOWN
          IF WholeWords
            Flags += FT_WHOLEWORD
          END
          IF CaseSensitive
            Flags += FT_MATCHCASE
          END
          WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
          SELF.FindTextEx.lpstrText  = ADDRESS(SearchString)
          SELF.FindTextEx.chrg.cpMin = SELF.CharRange.cpMax
          SELF.FindTextEx.chrg.cpMax = SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
          WM = SendMessage(SELF.RTFhwnd, EM_FINDTEXTEX, Flags, ADDRESS(SELF.FindTextEx))
          IF WM > -1
            ENABLE(?ButtonReplace,?ButtonReplaceAll)
            WM = SendMessage(SELF.RTFHwnd, EM_SETSEL, SELF.FindTextEx.chrgText.cpMin, SELF.FindTextEx.chrgText.cpMax)
          ELSE
            BEEP(SELF.Setup.WarningSound)
            IF MESSAGE('   "' & SearchString & '" not found.|   Continue from start of file?','Search',ICON:Question,BUTTON:Yes+BUTTON:No) = BUTTON:Yes
              WM = SendMessage(SELF.RTFhwnd, EM_SETSEL, 0, 0)
              POST(EVENT:Accepted, ?ButtonFind)
            ELSE
              BREAK
            END
          END
        OF ?ButtonReplace
          DISABLE(?ButtonReplace,?ButtonReplaceAll)
          WM = SendMessage(SELF.RTFhwnd, EM_REPLACESEL, TRUE, ADDRESS(ReplaceString))
          POST(EVENT:Accepted, ?ButtonFind)
        OF ?ButtonReplaceAll
          DISABLE(?ButtonReplace,?ButtonReplaceAll)
          LOOP
            WM = SendMessage(SELF.RTFhwnd, EM_REPLACESEL, TRUE, ADDRESS(ReplaceString))
            WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
            SELF.FindTextEx.chrg.cpMin = SELF.CharRange.cpMax
            WM = SendMessage(SELF.RTFhwnd, EM_FINDTEXTEX, Flags, ADDRESS(SELF.FindTextEx))
            IF WM > -1
              WM = SendMessage(SELF.RTFHwnd, EM_SETSEL, SELF.FindTextEx.chrgText.cpMin, SELF.FindTextEx.chrgText.cpMax)
            END
          UNTIL WM < 0
        OF ?ButtonCancel
          BREAK
        END
      END
    END
    CLOSE(FindTextWindow)
  ELSE
    BEEP(SELF.Setup.WarningSound)
  END

  SELF.Setup.PopupReplaceText = FALSE

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Reads the info for the pressent character and paragraph. If the Rich Edit Control has focus the function returns TRUE
!|  else it returns FALSE
!|
LocRichEditClass.ToggleUrlDetect    PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  WM = SendMessage(SELF.RTFhwnd, EM_AUTOURLDETECT, ABS(SendMessage(SELF.RTFhwnd, EM_GETAUTOURLDETECT, 0, 0) - 1), 0)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Reads the info for the present character and paragraph. If the Rich Edit Control has focus the function returns TRUE
!|  else it returns FALSE
!|
LocRichEditClass.ReadInfo           PROCEDURE()

WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  CLEAR(SELF.Info)

  ! --- Read all info about charformat ---
  SELF.CharFormat.dwMask = 0FFFFFFFFH
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, ADDRESS(SELF.CharFormat)))

  SELF.Info.Face        = SELF.CharFormat.szFaceName
  SELF.Info.Size        = SELF.CharFormat.yHeight / 20
  SELF.Info.Color       = SELF.CharFormat.crTextColor
  SELF.Info.SubScript   = BAND(SELF.CharFormat.dwEffects, CFE_SUBSCRIPT)
  SELF.Info.SuperScript = BAND(SELF.CharFormat.dwEffects, CFE_SUPERSCRIPT)

  IF BAND(SELF.CharFormat.dwEffects, CFE_BOLD)      THEN SELF.Info.Bold      = TRUE.
  IF BAND(SELF.CharFormat.dwEffects, CFE_ITALIC)    THEN SELF.Info.Italic    = TRUE.
  IF BAND(SELF.CharFormat.dwEffects, CFE_UNDERLINE) THEN SELF.Info.Underline = TRUE.
  IF BAND(SELF.CharFormat.dwEffects, CFE_STRIKEOUT) THEN SELF.Info.StrikeOut = TRUE.
  IF NOT SELF.Info.Bold AND NOT SELF.Info.Italic AND NOT SELF.Info.Underline AND NOT SELF.Info.StrikeOut
    SELF.Info.Regular = TRUE
  END

  IF BAND(SELF.CharFormat.dwMask, CFM_FACE)        THEN SELF.Info.FullFace = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFM_SIZE)        THEN SELF.Info.FullSize = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFE_SUBSCRIPT)   THEN SELF.Info.FullSubScript = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFE_SUPERSCRIPT) THEN SELF.Info.FullSuperScript = TRUE.

  IF BAND(SELF.CharFormat.dwMask, CFM_BOLD)        THEN SELF.Info.FullBold = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFM_ITALIC)      THEN SELF.Info.FullItalic = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFM_UNDERLINE)   THEN SELF.Info.FullUnderline = TRUE.
  IF BAND(SELF.CharFormat.dwMask, CFM_STRIKEOUT)   THEN SELF.Info.FullStrikeout = TRUE.
  IF SELF.Info.FullBold AND SELF.Info.FullItalic AND SELF.Info.FullUnderline AND SELF.Info.FullStrikeOut
    SELF.Info.FullRegular = TRUE
  END

  ! --- Read all info about paraformat ---
  SELF.ParaFormat.dwMask = 0FFFFFFFFH
  ASSERT(SendMessage(SELF.RTFhwnd, EM_GETPARAFORMAT, 0, ADDRESS(SELF.ParaFormat)))
  SELF.Info.Bullet       =  SELF.ParaFormat.wNumbering

  CASE SELF.ParaFormat.wAlignment
  OF 1
    SELF.Info.Left   = TRUE
  OF 2
    SELF.Info.Right  = TRUE
  OF 3
    SELF.Info.Center = TRUE
  END

  CASE SELF.ParaFormat.bLineSpacingRule
  OF 0
    SELF.Info.Single      = TRUE
  OF 1
    SELF.Info.OneAndAHalf = TRUE
  OF 2
    SELF.Info.Double      = TRUE
  END
  IF BAND(SELF.ParaFormat.dwMask, PFM_ALIGNMENT)
    SELF.Info.FullLeft = TRUE
    SELF.Info.FullCenter = TRUE
    SELF.Info.FullRight = TRUE
  END
  IF BAND(SELF.ParaFormat.dwMask, PFM_LINESPACING)
    SELF.Info.FullSingle = TRUE
    SELF.Info.FullOneAndAHalf = TRUE
    SELF.Info.FullDouble = TRUE
  END
  IF BAND(SELF.ParaFormat.dwMask, PFM_NUMBERING) THEN SELF.Info.FullBullet = TRUE.

  SELF.Info.Modified   = SendMessage(SELF.RTFhwnd, EM_GETMODIFY, 0, 0)
  IF SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0) THEN SELF.Info.ContainText = TRUE.
  WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
  IF SELF.CharRange.cpMin < SELF.CharRange.cpMax THEN SELF.Info.SelectedText = TRUE.
  SELF.Info.CanPaste   = SendMessage(SELF.RTFhwnd, EM_CANPASTE, 0, 0)
  SELF.Info.CanUndo    = SendMessage(SELF.RTFhwnd, EM_CANUNDO, 0, 0)
  SELF.Info.CanRedo    = SendMessage(SELF.RTFhwnd, EM_CANREDO, 0, 0)
  SELF.Info.LineNumber = SendMessage(SELF.RTFhwnd, EM_LINEFROMCHAR, SELF.CharRange.cpMin, 0) + 1
  SELF.Info.CharNumber = SELF.CharRange.cpMin - SendMessage(SELF.RTFhwnd, EM_LINEINDEX, SELF.Info.LineNumber - 1, 0) + 1

  SELF.Info.UrlDetectState = SendMessage(SELF.RTFhwnd, EM_GETAUTOURLDETECT, 0, 0)

  SELF.Info.MailOpen = SELF.MailFileOpen
  CASE SELF.MailFileEnd
  OF -1
    SELF.Info.MailFileBof = TRUE
  OF 1
    SELF.Info.MailFileEof = TRUE
  END
  IF SELF.MailRecords <= 1
    SELF.Info.MailFileBof = TRUE
    SELF.Info.MailFileEof = TRUE
  END

  IF SELF.RTFhwnd = GetFocus()
    RETURN(TRUE)
  ELSE
    RETURN(FALSE)
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Updata buttons and menus
!|
LocRichEditClass.UpdateButtons      PROCEDURE()

Control     CSTRING(25)
Info        &LONG
Full        LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  ! --- Update statusline with cursorpos --------
  IF SELF.Setup.StatusBar
    SELF.ParentWindow{PROP:StatusText, 1} = SELF.FileName
    SELF.ParentWindow{PROP:StatusText, 2} = 'Line: ' & SELF.Info.LineNumber & '   Col: ' & SELF.Info.CharNumber
    SELF.ParentWindow{PROP:StatusText, 3} = CHOOSE(SELF.Info.Modified + 1, '', 'Modified')
    SELF.ParentWindow{PROP:Text} = SELF.Setup.WindowCaption & ' - ' & SELF.StripFileName
  END

  ! --- If no toolbar and menu then exit --------
  IF SELF.ButtonQueue &= NULL
    RETURN
  END

  ! --- Buttons ---------------------------------
  SELF.ButtonQueue.ControlType = 'PRINT';        GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'FINDTEXT';     GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'FINDNEXTTEXT'; GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'REPLACETEXT';  GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'COPY';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.SelectedText - 1.
  SELF.ButtonQueue.ControlType = 'CUT';          GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.SelectedText - 1.
  SELF.ButtonQueue.ControlType = 'PASTE';        GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.CanPaste - 1.
  SELF.ButtonQueue.ControlType = 'UNDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.CanUndo - 1.
  SELF.ButtonQueue.ControlType = 'REDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.CanRedo - 1.
  SELF.ButtonQueue.ControlType = 'SELECTALL';    GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'URLDETECT';    GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN SELF.ButtonQueue.ButtonEquate{PROP:Use}     = SELF.Info.UrlDetectState.
  ! --- Font List and Size ----------------------
  SELF.ButtonQueue.ControlType = 'LISTFONTS';    GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN IF SELF.Info.FullFace THEN SELF.ButtonQueue.ButtonEquate{PROP:Use} = SELF.Info.Face ELSE SELF.ButtonQueue.ButtonEquate{PROP:ScreenText} = ''..
  SELF.ButtonQueue.ControlType = 'LISTFONTSIZE'; GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.ButtonEquate THEN IF SELF.Info.FullSize THEN SELF.ButtonQueue.ButtonEquate{PROP:Use} = SELF.Info.Size ELSE SELF.ButtonQueue.ButtonEquate{PROP:ScreenText} = ''..
  ! --- Menus -----------------------------------
  SELF.ButtonQueue.ControlType = 'PRINT';        GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'FINDTEXT';     GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'FINDNEXTTEXT'; GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'REPLACETEXT';  GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'COPY';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.SelectedText - 1.
  SELF.ButtonQueue.ControlType = 'CUT';          GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.SelectedText - 1.
  SELF.ButtonQueue.ControlType = 'PASTE';        GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.CanPaste - 1.
  SELF.ButtonQueue.ControlType = 'UNDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.CanUndo - 1.
  SELF.ButtonQueue.ControlType = 'REDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.CanRedo - 1.
  SELF.ButtonQueue.ControlType = 'SELECTALL';    GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN SELF.ButtonQueue.MenuEquate{PROP:Disable} = SELF.Info.ContainText - 1.
  SELF.ButtonQueue.ControlType = 'URLDETECT';    GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType); IF NOT ERRORCODE() AND SELF.ButtonQueue.MenuEquate THEN IF SELF.ButtonQueue.MenuEquate{PROP:Icon} THEN IF SELF.Info.UrlDetectState THEN SELF.ButtonQueue.MenuEquate{PROP:Icon} = '~RtfUrlDetect_d.ico' ELSE SELF.ButtonQueue.MenuEquate{PROP:Icon} = '~RtfUrlDetect.ico'. ELSE SELF.ButtonQueue.MenuEquate{PROP:Use} = SELF.Info.UrlDetectState..
  ! --- Set Undo and Redo names -----------------
  SELF.ButtonQueue.ControlType = 'UNDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType)
  SELF.ButtonQueue.ButtonEquate{PROP:Tip} = 'Undo - ' & CHOOSE(SendMessage(SELF.RtfHwnd, EM_GETUNDONAME, 0, 0) + 1, 'Text format', 'Text typing', 'Text delete', 'Text drag/drop', 'Text cut', 'Text paste')
  SELF.ButtonQueue.ControlType = 'REDO';         GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType)
  SELF.ButtonQueue.ButtonEquate{PROP:Tip} = 'Redo - ' & CHOOSE(SendMessage(SELF.RtfHwnd, EM_GETREDONAME, 0, 0) + 1, 'Text format', 'Text typing', 'Text delete', 'Text drag/drop', 'Text cut', 'Text paste')
  ! --- Check, disable or gray cotrols ----------
  Control = 'REGULAR';      Info &= SELF.Info.Regular;      Full = SELF.Info.FullRegular;       DO UpdateButton
  Control = 'BOLD';         Info &= SELF.Info.Bold;         Full = SELF.Info.FullBold;          DO UpdateButton
  Control = 'ITALIC';       Info &= SELF.Info.Italic;       Full = SELF.Info.FullItalic;        DO UpdateButton
  Control = 'UNDERLINE';    Info &= SELF.Info.Underline;    Full = SELF.Info.FullUnderline;     DO UpdateButton
  Control = 'STRIKEOUT';    Info &= SELF.Info.Strikeout;    Full = SELF.Info.FullStrikeout;     DO UpdateButton
  Control = 'LEFT';         Info &= SELF.Info.Left;         Full = SELF.Info.FullLeft;          DO UpdateButton
  Control = 'CENTER';       Info &= SELF.Info.Center;       Full = SELF.Info.FullCenter;        DO UpdateButton
  Control = 'RIGHT';        Info &= SELF.Info.Right;        Full = SELF.Info.FullRight;         DO UpdateButton
  Control = 'BULLET';       Info &= SELF.Info.Bullet;       Full = SELF.Info.FullBullet;        DO UpdateButton
  Control = 'SINGLE';       Info &= SELF.Info.Single;       Full = SELF.Info.FullSingle;        DO UpdateButton
  Control = 'ONEANDAHALF';  Info &= SELF.Info.OneAndAHalf;  Full = SELF.Info.FullOneAndAHalf;   DO UpdateButton
  Control = 'DOUBLE';       Info &= SELF.Info.Double;       Full = SELF.Info.FullDouble;        DO UpdateButton
  Control = 'SUBSCRIPT';    Info &= SELF.Info.SubScript;    Full = SELF.Info.FullSubScript;     DO UpdateButton
  Control = 'SUPERSCRIPT';  Info &= SELF.Info.SuperScript;  Full = SELF.Info.FullSuperScript;   DO UpdateButton

UpdateButton ROUTINE

  SELF.ButtonQueue.ControlType = Control
  GET(SELF.ButtonQueue, SELF.ButtonQueue.ControlType)
  IF NOT ERRORCODE()
    IF SELF.ButtonQueue.ButtonEquate
      SELF.ButtonQueue.ButtonEquate{PROP:Use} = Info
      IF Full
        IF SELF.ButtonQueue.ButtonEquate{PROP:Icon} <> '~Rtf' & Control & '.ico'
          SELF.ButtonQueue.ButtonEquate{PROP:Icon} = '~Rtf' & Control & '.ico'
        END
      ELSE
        IF SELF.ButtonQueue.ButtonEquate{PROP:Icon} <> '~Rtf' & Control & 'Dis.ico'
          SELF.ButtonQueue.ButtonEquate{PROP:Icon} = '~Rtf' & Control & 'Dis.ico'
        END
      END
    END
    IF SELF.ButtonQueue.MenuEquate
      SELF.ButtonQueue.MenuEquate{PROP:Use} = Info
      IF SELF.ButtonQueue.MenuEquate{PROP:Icon}
        IF Full
          IF Info
            SELF.ButtonQueue.MenuEquate{PROP:Icon} = '~Rtf' & Control & '_d.ico'
          ELSE
            SELF.ButtonQueue.MenuEquate{PROP:Icon} = '~Rtf' & Control & '.ico'
          END
        ELSE
          SELF.ButtonQueue.MenuEquate{PROP:Icon} = '~Rtf' & Control & 'Dis.ico'
        END
      END
    END
  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Update the window and all buttons and tabulator
!|
LocRichEditClass.UpdateWindow       PROCEDURE()

  CODE

  ASSERT(SELF.RTFhwnd)

  MsgQueue.WndHwnd = SELF.RTFhwnd
  GET(MsgQueue, MsgQueue.WndHwnd)
  IF NOT ERRORCODE()
    MsgQueue.WndClass.ReadInfo
    MsgQueue.WndClass.UpdateTabulator
    MsgQueue.WndClass.UpdateButtons
  END

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Dummy procedure for WM_KEYUP event
!|
LocRichEditClass.WindowEvent        PROCEDURE(UNSIGNED wMsg, WPARAM wParam, LPARAM lParam)

  CODE

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Insert formatet Date or Time in text
!|
LocRichEditClass.DateTime           PROCEDURE()

NowQueue        QUEUE
Now               CSTRING(20)
                END

PictureString   CSTRING(25)
PictureNumber   BYTE
SelectedItem    LONG,STATIC
WM              LONG
DateTimeWindow  WINDOW('Insert Date/Time'),AT(,,95,104),FONT('MS Sans Serif',8,,),SYSTEM,TOOLBOX,GRAY,DOUBLE
                  LIST,AT(0,0),USE(?NowList),FULL,VSCROLL,LEFT(2),ALRT(MouseLeft2),ALRT(MouseRight),ALRT(EnterKey),FORMAT('200L(2)'),FROM(NowQueue)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.Setup.PopupDateTime = THREAD()

  ! --- Add Date ---
  LOOP PictureNumber = 18 TO 1 BY -1
    PictureString = '@D' & PictureNumber
    NowQueue.Now = CLIP(LEFT(FORMAT(TODAY(), PictureString))) & ' '
    GET(NowQueue, NowQueue.Now)
    IF ERRORCODE()
      ADD(NowQueue)
    END
  END
  ! --- Add seperator ---
  NowQueue.Now = ''
  ADD(NowQueue)
  ! --- Add Time ---
  LOOP PictureNumber = 8 TO 1 BY -1
    PictureString = '@T' & PictureNumber
    NowQueue.Now = CLIP(LEFT(FORMAT(CLOCK(), PictureString))) & ' '
    GET(NowQueue, NowQueue.Now)
    IF ERRORCODE()
      ADD(NowQueue)
    END
  END

  SYSTEM{PROP:Icon} = '~RichEdit.ico'
  OPEN(DateTimeWindow, SELF.ParentWindow)
  SYSTEM{PROP:Icon} = SELF.Setup.SystemIcon

  SETPOSITION(0, SELF.ParentWindow{PROP:XPos} + SELF.ParentWindow{PROP:Width} - 0{PROP:Width} - 15, SELF.ParentWindow{PROP:Ypos} + 15)

  ?NowList{PROP:Selected} = SelectedItem
  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF MouseLeft2 OROF EnterKey
      SelectedItem = CHOICE(?NowList)
      GET(NowQueue, SelectedItem)
      IF ERRORCODE()
        BEEP(SELF.Setup.WarningSound)
        CYCLE
      END
      WM = SendMessage(SELF.RTFhwnd, EM_REPLACESEL, TRUE, ADDRESS(NowQueue.Now))
      POST(EVENT:CloseWindow)
      OF MouseRight
        POST(EVENT:CloseWindow)
      END
    END
  END

  CLOSE(DateTimeWindow)
  FREE(NowQueue)

  SELF.Setup.PopupDateTime = FALSE

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open Mail Merge Window
!|
LocRichEditClass.MailMerge          PROCEDURE()

WM              LONG
ControlEquate   LONG
WindowRect      LIKE(_RECT)

MailWindow      WINDOW('Mail Merge'),AT(,,187,18),FONT('MS Sans Serif',8,,),CENTER,IMM,DOCK(DOCK:all),DOCKED(DOCK:left),SYSTEM,TOOLBOX,GRAY,DOUBLE
                  PANEL,AT(1,1,3,16),USE(?DragPanel),BEVEL(0,0,09060H)
                  BUTTON,AT(7,1,18,16),USE(?RTF:MailInsert),TIP('Insert mail field'),ICON('RtfMailInsert.ico')
                  CHECK,AT(29,1,18,16),USE(?RTF:MailView),TIP('Merge to screen'),ICON('RtfMailView.ico')
                  BUTTON,AT(47,1,18,16),USE(?RTF:MailPrint),TIP('Merge to printer'),ICON('RtfMailPrint.ico')
                  BUTTON,AT(69,1,18,16),USE(?RTF:MailFirst),TIP('First record'),ICON('RtfMailFirst.ico')
                  BUTTON,AT(87,1,18,16),USE(?RTF:MailPrevious),TIP('Previous record'),ICON('RtfMailPrevious.ico')
                  BUTTON,AT(105,1,18,16),USE(?RTF:MailNext),TIP('Next record'),ICON('RtfMailNext.ico')
                  BUTTON,AT(123,1,18,16),USE(?RTF:MailLast),TIP('Last record'),ICON('RtfMailLast.ico')
                  BUTTON,AT(145,1,18,16),USE(?RTF:MailFilter),TIP('Filter/Order records'),ICON('RtfMailFilter.ico')
                  BUTTON,AT(167,1,18,16),USE(?RTF:MailPrintCurrent),TIP('Print current document'),ICON(ICON:Print)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.Setup.PopupMailMerge = THREAD()

  SYSTEM{PROP:Icon} = '~RichEdit.ico'
  OPEN(MailWindow, SELF.ParentWindow)
  SYSTEM{PROP:Icon} = SELF.Setup.SystemIcon

  IF SELF.Setup.FlatButtons
    LOOP ControlEquate = FIRSTFIELD() TO LASTFIELD()
      ControlEquate{PROP:Flat} = TRUE
    END
  END

  MailWindow{PROP:SnapWidth, 1}  = 22;  MailWindow{PROP:SnapHeight, 1} = 169  !  Vertical   size i.e., when made tall
  MailWindow{PROP:SnapWidth, 2}  = 187; MailWindow{PROP:SnapHeight, 2} = 18   !  Horizontal size i.e., when made wide

  ACCEPT
    CASE ACCEPTED()
    OF ?RTF:MailInsert
!      SELF.MailInsert
      IF SELF.Setup.PopupMailInsert                              !bk
        POST(EVENT:CloseWindow,, SELF.Setup.PopupMailInsert, 1)  !bk
        SELF.Setup.PopupMailInsert=FALSE                         !bk
      ELSE                                                       !bk
        SELF.ShowToolBox('MAILINSERT')                           !bk
      END                                                        !bk
    OF ?RTF:MailView
      SELF.MailScreen(BXOR(SELF.MailFileOpen, TRUE))
    OF ?RTF:MailPrint
      SELF.MailPrinter
    OF ?RTF:MailFirst
      SELF.MailLocate(1)
    OF ?RTF:MailPrevious
      SELF.MailLocate(2)
    OF ?RTF:MailNext
      SELF.MailLocate(3)
    OF ?RTF:MailLast
      SELF.MailLocate(4)
    OF ?RTF:MailFilter
      SELF.MailFilter
    OF ?RTF:MailPrintCurrent
      SELF.PrintDoc(FALSE)
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      SELF.MailScreen(FALSE)
      MailWindow{PROP:Docked} = DOCK:Float
      POST(EVENT:UnDocked,,,1)
    OF EVENT:Sized
      CASE MailWindow{PROP:Width}
      OF 22
        ?DragPanel{PROP:Width}           = 18;  ?DragPanel{PROP:Height}          = 3;  ?DragPanel{PROP:BevelStyle} = 00906H
        ?RTF:MailInsert{PROP:XPos}       = 1;   ?RTF:MailInsert{PROP:YPos}       = 7
        ?RTF:MailView{PROP:XPos}         = 1;   ?RTF:MailView{PROP:YPos}         = 27
        ?RTF:MailPrint{PROP:XPos}        = 1;   ?RTF:MailPrint{PROP:YPos}        = 43
        ?RTF:MailFirst{PROP:XPos}        = 1;   ?RTF:MailFirst{PROP:YPos}        = 63
        ?RTF:MailPrevious{PROP:XPos}     = 1;   ?RTF:MailPrevious{PROP:YPos}     = 79
        ?RTF:MailNext{PROP:XPos}         = 1;   ?RTF:MailNext{PROP:YPos}         = 95
        ?RTF:MailLast{PROP:XPos}         = 1;   ?RTF:MailLast{PROP:YPos}         = 111
        ?RTF:MailFilter{PROP:XPos}       = 1;   ?RTF:MailFilter{PROP:YPos}       = 131
        ?RTF:MailPrintCurrent{PROP:XPos} = 1;   ?RTF:MailPrintCurrent{PROP:YPos} = 151
      OF 187
        ?DragPanel{PROP:Width}           = 3;   ?DragPanel{PROP:Height}          = 16; ?DragPanel{PROP:BevelStyle} = 09060H
        ?RTF:MailInsert{PROP:XPos}       = 7;   ?RTF:MailInsert{PROP:YPos}       = 1
        ?RTF:MailView{PROP:XPos}         = 29;  ?RTF:MailView{PROP:YPos}         = 1
        ?RTF:MailPrint{PROP:XPos}        = 47;  ?RTF:MailPrint{PROP:YPos}        = 1
        ?RTF:MailFirst{PROP:XPos}        = 69;  ?RTF:MailFirst{PROP:YPos}        = 1
        ?RTF:MailPrevious{PROP:XPos}     = 87;  ?RTF:MailPrevious{PROP:YPos}     = 1
        ?RTF:MailNext{PROP:XPos}         = 105; ?RTF:MailNext{PROP:YPos}         = 1
        ?RTF:MailLast{PROP:XPos}         = 123; ?RTF:MailLast{PROP:YPos}         = 1
        ?RTF:MailFilter{PROP:XPos}       = 145; ?RTF:MailFilter{PROP:YPos}       = 1
        ?RTF:MailPrintCurrent{PROP:XPos} = 167; ?RTF:MailPrintCurrent{PROP:YPos} = 1
      END
    OF EVENT:Docked OROF EVENT:UnDocked
      MailWindow{PROP:Pixels} = TRUE
      CASE MailWindow{PROP:Docked}
      OF DOCK:Left OROF DOCK:Right
        SELF.Setup.DockedWidth  = MailWindow{PROP:Width} + 2
        SELF.Setup.DockedHeight = 0
      OF DOCK:Top OROF DOCK:Bottom
        SELF.Setup.DockedWidth  = 0
        SELF.Setup.DockedHeight = MailWindow{PROP:Height} + 2
      ELSE
        SELF.Setup.DockedWidth  = 0
        SELF.Setup.DockedHeight = 0
      END
      SELF.ParentWindow{PROP:Pixels} = TRUE
      MoveWindow(SELF.RTFHwnd, SELF.Setup.ControlXPos , SELF.Setup.ControlYPos, INT(SELF.Setup.ControlWidth + SELF.ParentWindow{PROP:Width} - SELF.Setup.WindowWidth) - SELF.Setup.DockedWidth, INT(SELF.Setup.ControlHeight + SELF.ParentWindow{PROP:Height} - SELF.Setup.WindowHeight) - SELF.Setup.DockedHeight, TRUE)
      SELF.ParentWindow{PROP:Pixels} = SELF.Setup.PixelState
      MailWindow{PROP:Pixels} = FALSE
    END
    DO UpdateMailButtons
  END

  SELF.MailScreen(FALSE)

  SELF.UpdateWindow
  CLOSE(MailWindow)

  SELF.Setup.PopupMailMerge = FALSE

UpdateMailButtons   ROUTINE

  SELF.ReadInfo
  ?RTF:MailInsert{PROP:Disable}         = SELF.Info.MailOpen
  ?RTF:MailView{PROP:Use}               = SELF.Info.MailOpen
  ?RTF:MailPrint{PROP:Disable}          = SELF.Info.MailOpen
  ?RTF:MailFirst{PROP:Disable}          = BOR(SELF.Info.MailOpen - 1, SELF.Info.MailFileBof)
  ?RTF:MailPrevious{PROP:Disable}       = BOR(SELF.Info.MailOpen - 1, SELF.Info.MailFileBof)
  ?RTF:MailNext{PROP:Disable}           = BOR(SELF.Info.MailOpen - 1, SELF.Info.MailFileEof)
  ?RTF:MailLast{PROP:Disable}           = BOR(SELF.Info.MailOpen - 1, SELF.Info.MailFileEof)
  ?RTF:MailFilter{PROP:Disable}         = SELF.Info.MailOpen
  ?RTF:MailPrintCurrent{PROP:Disable}   = SELF.Info.MailOpen - 1
  SELF.ParentWindow{PROP:StatusText, 1} = SELF.TempFileName

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Fill File Queue with files
!|
LocRichEditClass.InitMailFile       PROCEDURE(STRING FileName, FILE FileLabel, *GROUP FileRecord, VIEW FileView)

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.MailFileQueue &= NULL
    SELF.MailFileQueue &= NEW(_FILEQUEUE)
  END

  SELF.MailFileQueue.FileName    = FileName
  SELF.MailFileQueue.FileLabel  &= FileLabel
  SELF.MailFileQueue.FileRecord &= FileRecord
  SELF.MailFileQueue.FileView   &= FileView
  ADD(SELF.MailFileQueue)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Insert file filed into document
!|
LocRichEditClass.MailInsert         PROCEDURE()

FieldQueue      QUEUE
FieldName         CSTRING(256)
                END
RecNumber       LONG
InsertString    CSTRING(256)
SelectedFile    LONG,STATIC
WM              LONG
PickField WINDOW('Insert Field'),AT(,,130,130),FONT('MS Sans Serif',8,,),SYSTEM,TOOLBOX,GRAY,DOUBLE
       LIST,AT(0,0,,12),USE(?FileList),FULL,VSCROLL,FORMAT('200L(2)'),DROP(10),FROM(SELF.MailFileQueue)
       LIST,AT(0,14),USE(?FieldList),FULL,VSCROLL,ALRT(MouseLeft2),ALRT(MouseRight),ALRT(EnterKey),FORMAT('200L(2)'), |
           FROM(FieldQueue)
     END
  CODE

  ASSERT(SELF.RTFhwnd)

  SELF.Setup.PopupMailInsert = THREAD()

   IF RECORDS(SELF.MailFileQueue)
    SYSTEM{PROP:Icon} = '~RichEdit.ico'
    OPEN(PickField, SELF.ParentWindow)
    SYSTEM{PROP:Icon} = SELF.Setup.SystemIcon
    IF SelectedFile
      ?FileList{PROP:Selected} = SelectedFile
    ELSE
      ?FileList{PROP:Selected} = 1
    END
    DO FillFieldList

    SETPOSITION(0, SELF.ParentWindow{PROP:XPos} + SELF.ParentWindow{PROP:Width} - 0{PROP:Width} - 15, SELF.ParentWindow{PROP:Ypos} + 140)

    ACCEPT
      CASE EVENT()
      OF EVENT:AlertKey
        CASE KEYCODE()
        OF MouseLeft2 OROF EnterKey
          IF ?FieldList{PROPLIST:MouseDownField} = 1
            GET(FieldQueue, CHOICE(?FieldList))
            IF ERRORCODE()
              BEEP(SELF.Setup.WarningSound)
              CYCLE
            END
            InsertString = '<<<<' & FieldQueue.FieldName & '>>'
            WM = SendMessage(SELF.RTFhwnd, EM_REPLACESEL, TRUE, ADDRESS(InsertString))
          END
        OF MouseRight
          POST(EVENT:CloseWindow)
        END
      OF EVENT:NewSelection
        IF FIELD() = ?FileList
          DO FillFieldList
        END
      END
    END

    SelectedFile = ?FileList{PROP:Selected}
    CLOSE(PickField)
    FREE(FieldQueue)

  END

  SELF.SetFocus

FillFieldList       ROUTINE

  GET(SELF.MailFileQueue, CHOICE(?FileList))
  FREE(FieldQueue)
  OPEN(SELF.MailFileQueue.FileLabel)
  LOOP RecNumber = 1 TO SELF.MailFileQueue.FileLabel{PROP:Fields}
    FieldQueue.FieldName = SELF.MailFileQueue.FileLabel{PROP:Label, RecNumber}
    ADD(FieldQueue)
  END
  CLOSE(SELF.MailFileQueue.FileLabel)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Set Mail Merge Filter for processed records.
!|
LocRichEditClass.MailFilter         PROCEDURE()

FilterValue     CSTRING(256)
OrderValue      CSTRING(256)
_Filter         BOOL
_Order          BOOL
WM              LONG
FilterWindow    WINDOW('Mail Merge Filter and Order'),AT(,,270,80),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
                  SHEET,AT(4,4,262,53),USE(?Sheet1),SPREAD
                    TAB('Record &Filter'),USE(?TabFilter)
                      STRING('Set filter in the form:  PRE:FieldName = ''Filtervalue'''),AT(9,26)
                      ENTRY(@s255),AT(9,39,251,12),USE(FilterValue),IMM,LEFT(2)
                    END
                    TAB('Record &Order'),USE(?TabOrder)
                      STRING('Set order in the form:  +PRE:FieldName, -PRE:FieldName'),AT(9,26)
                      ENTRY(@s255),AT(9,39,251,12),USE(OrderValue),IMM,LEFT(2)
                    END
                  END
                  BUTTON('&Clear filter and order'),AT(4,62,78,14),USE(?ButtonClear)
                  BUTTON('&Ok'),AT(194,62,34,14),USE(?ButtonOk),DEFAULT
                  BUTTON('Cancel'),AT(231,62,,14),USE(?ButtonCancel)
                END

  CODE

  ASSERT(SELF.RTFhwnd)

  OPEN(FilterWindow)
  FilterValue = SELF.MailFilterValue
  OrderValue  = SELF.MailOrderValue
  ACCEPT
    CASE EVENT()
    OF EVENT:Accepted
      CASE FIELD()
      OF ?ButtonOk
        SELF.MailFilterValue = FilterValue
        SELF.MailOrderValue  = OrderValue
        POST(EVENT:CloseWindow)
      OF ?ButtonCancel
        POST(EVENT:CloseWindow)
      OF ?ButtonClear
        CLEAR(FilterValue)
        CLEAR(OrderValue)
        DISPLAY()
        SELECT(?FilterValue)
      END
    OF EVENT:NewSelection
      UPDATE(?)
    END
    IF FilterValue THEN _Filter = TRUE ELSE _Filter = FALSE.
    IF (_Filter AND ?TabFilter{PROP:FontStyle} <> FONT:Bold) OR (NOT _Filter AND ?TabFilter{PROP:FontStyle} = FONT:Bold) THEN ?TabFilter{PROP:FontStyle} = FONT:Bold * _Filter.
    IF OrderValue THEN _Order = TRUE ELSE _Order = FALSE.
    IF (_Order AND ?TabOrder{PROP:FontStyle} <> FONT:Bold) OR (NOT _Order AND ?TabOrder{PROP:FontStyle} = FONT:Bold) THEN ?TabOrder{PROP:FontStyle} = FONT:Bold * _Order.
  END
  CLOSE(FilterWindow)

  ! --- Update numbers of records available
  WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(SELF.CharRange))
  SELF.MailScreen(TRUE)
  SELF.MailScreen(FALSE)
  WM = SendMessage(SELF.RTFhwnd, EM_SETSEL, SELF.CharRange.cpMin, SELF.CharRange.cpMax)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Merge records to screen
!|  ScreenOn:   TRUE - Open File, FALSE - Close File
!|
LocRichEditClass.MailScreen         PROCEDURE(BYTE ScreenOn)

FieldName       STRING(256)
FieldLabel      CSTRING(256)
FileNumber      LONG
FieldNumber     LONG
CharRange       LIKE(_CHARRANGE),STATIC
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF ScreenOn   ! Open Merge to Screen
    Dummy#=1    !bk Needed to make merge work
    WM = SendMessage(SELF.RTFhwnd, EM_EXGETSEL, 0, ADDRESS(CharRange))
    SELF.MailLocate(0, FieldName) ! Find first field in document
    LOOP FileNumber = 1 TO RECORDS(SELF.MailFileQueue)  
      GET(SELF.MailFileQueue, FileNumber)
      OPEN(SELF.MailFileQueue.FileLabel)
      SET(SELF.MailFileQueue.FileLabel)
      NEXT(SELF.MailFileQueue.FileLabel)
      LOOP FieldNumber = 1 TO SELF.MailFileQueue.FileLabel{PROP:Fields}
        FieldLabel = SELF.MailFileQueue.FileLabel{PROP:Label, FieldNumber}
        IF FieldLabel = FieldName
          BIND(SELF.MailFileQueue.FileRecord)
          SELF.MailFileName &= SELF.MailFileQueue.FileLabel
          SELF.MailFileView &= SELF.MailFileQueue.FileView
          SELF.MailFileView{PROP:Order} = SELF.MailOrderValue
          IF ERRORCODE()
            BEEP(SELF.Setup.WarningSound)
            MESSAGE('   Illegal order expression. Order is ignored.', 'Order Error', ICON:Exclamation)
            SELF.MailFileView{PROP:Order} = ''
          END
          SELF.MailFileView{PROP:Filter} = SELF.MailFilterValue
          IF ERRORCODE()
            BEEP(SELF.Setup.WarningSound)
            MESSAGE('   Illegal filter expression. Filter is ignored.', 'Filter Error', ICON:Exclamation)
            SELF.MailFileView{PROP:Filter} = ''
          END
          STREAM(SELF.MailFileName)
          OPEN(SELF.MailFileView)
          SET(SELF.MailFileView)
          PREVIOUS(SELF.MailFileView)
          SELF.MailLastRecord = POINTER(SELF.MailFileName)
          SET(SELF.MailFileView)
          NEXT(SELF.MailFileView)
          IF ERRORCODE()
            SELF.MailRecords = 0
          ELSE
            SELF.MailRecords = 1
          END
          SELF.MailFirstRecord = POINTER(SELF.MailFileName)

          IF SELF.MailFileView{PROP:Filter}
            LOOP
              NEXT(SELF.MailFileView)
              IF ERRORCODE() THEN BREAK.
              SELF.MailRecords += 1
            END
          ELSE
            SELF.MailRecords = RECORDS(SELF.MailFileView)
          END

          SELF.MailDocumentModified = SendMessage(SELF.RTFhwnd, EM_GETMODIFY, 0, 0)
          SELF.TempFileName = SELF.FileName
          SELF.SaveDoc(,SELF.MailDocumentBuffer)
          SELF.MailLocate(1)
          SELF.MailFileOpen = TRUE
          RETURN
        END
      END
      CLOSE(SELF.MailFileQueue.FileLabel)
    END
  ELSE          ! Close Merge to Screen
    IF SELF.MailFileOpen
      SELF.MailFileOpen = FALSE
      IF SELF.Setup.PrinterHDC  ! Close Printer hDC if the printer has been used
        ASSERT(DeleteDC(SELF.Setup.PrinterHDC))
        CLEAR(SELF.Setup.PrinterHDC)
      END
      UNBIND(SELF.MailFileQueue.FileRecord)
      CLOSE(SELF.MailFileView)
      CLOSE(SELF.MailFileName)
      IF SELF.MailDocumentBuffer
        SELF.LoadDoc(,SELF.MailDocumentBuffer)
        SELF.FileName = SELF.TempFileName
        SELF.StripName
        CLEAR(SELF.TempFileName)
        WM = SendMessage(SELF.RTFhwnd, EM_SETMODIFY, SELF.MailDocumentModified, 0)
      END
      CLEAR(SELF.MailDocumentBuffer)
      0{PROP:StatusText, 1} = 'There is ' & SELF.MailRecords & ' record(s) in ' & SELF.MailFileQueue.FileName
    END
    WM = SendMessage(SELF.RTFhwnd, EM_SETSEL, CharRange.cpMin, CharRange.cpMax)
  END

  SELF.Info.MailOpen = SELF.MailFileOpen

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Merge all records to printer
!|
LocRichEditClass.MailPrinter        PROCEDURE()

OldWindowStyle  LONG
NewWindowStyle  LONG
PctProgress     LONG(0)
RecordNumber    LONG(0)
ProgressWindow  WINDOW('Mail Merge to Printer'),AT(,,140,37),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE,TIMER(1)
                  PROGRESS,USE(PctProgress),AT(5,5,130,8),RANGE(0,100)
                  BUTTON('Cancel'),USE(?CancelButton),AT(5,18,130,14),DEFAULT
                END

  CODE

  ASSERT(SELF.RTFhwnd)
  dummy#=1   !bk - needed to make merge work
  SELF.MailScreen(TRUE)
  IF SELF.MailFileOpen
    IF SELF.MailLocate(1)
      BEEP(SELF.Setup.WarningSound)
      IF MESSAGE('   Do you want to merge the ' & SELF.MailFileQueue.FileName & ' file to the printer.|   The file contains ' & SELF.MailRecords & ' record(s).', 'Mail Merge to Printer', ICON:QUESTION, BUTTON:Yes+BUTTON:No) = BUTTON:Yes
        ! --- Remove scrollbars ---
        NewWindowStyle = GetWindowLong(SELF.RTFhwnd, GWL_STYLE)
        IF BAND(NewWindowStyle, WS_VSCROLL) THEN NewWindowStyle = BXOR(NewWindowStyle, WS_VSCROLL).
        IF BAND(NewWindowStyle, WS_HSCROLL) THEN NewWindowStyle = BXOR(NewWindowStyle, WS_HSCROLL).
        OldWindowStyle = SetWindowLong(SELF.RTFhwnd, GWL_STYLE, NewWindowStyle)
        ! --------------------------
        OPEN(ProgressWindow)
        ACCEPT
          CASE EVENT()
          OF EVENT:Timer
            RecordNumber += 1
            PctProgress = RecordNumber * 100 / SELF.MailRecords
            DISPLAY(?PctProgress)
            SELF.PrintDoc(FALSE)
            IF NOT SELF.MailLocate(3)
              BREAK
            END
          OF EVENT:Accepted
            POST(EVENT:CloseWindow)
          OF EVENT:CloseWindow
            BEEP(SELF.Setup.WarningSound)
            IF MESSAGE('   Do you want to interrupt the mail merge to printer.', 'Interrupt Mail Merge', ICON:Question, BUTTON:Yes+BUTTON:No) = BUTTON:No
              CYCLE
            END
          END
        END
        CLOSE(ProgressWindow)
        ! --- Insert scrollbars ---
        NewWindowStyle = SetWindowLong(SELF.RTFhwnd, GWL_STYLE, OldWindowStyle)
        ! -------------------------
      END
    END
  END
  SELF.MailScreen(FALSE)

  SELF.SetFocus

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Locate field from file
!|  Direction:  0 - Return first field in FieldName, 1 - First record, 2 - Previous record, 3 - Next record, 4 - Last record
!|  FieldName:  Return value of the first mailfield in document
!|
LocRichEditClass.MailLocate         PROCEDURE(LONG Direction, <*STRING FieldName>)

SearchString    CSTRING(10)
ReplaceString   CSTRING(256)
FieldString     CSTRING(256)
FieldLabel      CSTRING(256)
StartPos        LONG
EndPos          LONG
StartString     LONG
EndString       LONG
FieldNumber     LONG
Flags           LONG
RecordNumber    LONG,STATIC
WM              LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF Direction AND SELF.MailDocumentBuffer
    CASE Direction
    OF 1  ! First Field
      SET(SELF.MailFileView)
      NEXT(SELF.MailFileView)
      RecordNumber = 1
    OF 2  ! Previous Field
      PREVIOUS(SELF.MailFileView)
      RecordNumber -= 1; IF RecordNumber < 1 THEN RecordNumber = 1.
    OF 3  ! Next Field
      NEXT(SELF.MailFileView)
      RecordNumber += 1; IF RecordNumber > SELF.MailRecords THEN RecordNumber = SELF.MailRecords.
    OF 4  ! Last Field
      SET(SELF.MailFileView)
      PREVIOUS(SELF.MailFileView)
      RecordNumber = RECORDS(SELF.MailFileView)
    END
    CASE POINTER(SELF.MailFileName)
    OF SELF.MailLastRecord
      SELF.MailFileEnd = 1
    OF SELF.MailFirstRecord
      SELF.MailFileEnd = -1
    ELSE
      SELF.MailFileEnd = 0
    END
    IF ERRORCODE()
      0{PROP:StatusText, 1} = 'No records to process.'
      RETURN(FALSE)
    END
    SELF.LoadDoc(,SELF.MailDocumentBuffer)
  END

  StartPos = 0
  Flags    = FR_DOWN
  LOOP
    SearchString = '<<<<'
    SELF.FindTextEx.lpstrText  = ADDRESS(SearchString)
    SELF.FindTextEx.chrg.cpMin = StartPos
    SELF.FindTextEx.chrg.cpMax = SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
    WM = SendMessage(SELF.RTFhwnd, EM_FINDTEXTEX, Flags, ADDRESS(SELF.FindTextEx))
    StartPos = SELF.FindTextEx.chrgText.cpMin
    StartString = SELF.FindTextEx.chrgText.cpMax
    IF WM < 0
      RETURN(TRUE)
    ELSE
      SearchString = '>>'
      SELF.FindTextEx.lpstrText  = ADDRESS(SearchString)
      SELF.FindTextEx.chrg.cpMin = StartPos
      SELF.FindTextEx.chrg.cpMax = SendMessage(SELF.RTFhwnd, WM_GETTEXTLENGTH, 0, 0)
      WM = SendMessage(SELF.RTFhwnd, EM_FINDTEXTEX, Flags, ADDRESS(SELF.FindTextEx))
      EndPos = SELF.FindTextEx.chrgText.cpMax
      EndString = SELF.FindTextEx.chrgText.cpMin
      IF WM < 0
        RETURN(FALSE)
      ELSE
        WM = SendMessage(SELF.RTFHwnd, EM_SETSEL, StartString, EndString)
        ASSERT(SendMessage(SELF.RTFhwnd, EM_GETSELTEXT, 0, ADDRESS(FieldString)))
        IF Direction = 0
          FieldName = FieldString
          RETURN(TRUE)
        END
        0{PROP:StatusText, 1} = 'Record ' & RecordNumber & ' of ' & SELF.MailRecords & ' record(s) in ' & SELF.MailFileQueue.FileName
        ReplaceString = 'Missing-field'
        LOOP FieldNumber = 1 TO SELF.MailFileQueue.FileLabel{PROP:Fields}
          FieldLabel = SELF.MailFileQueue.FileLabel{PROP:Label, FieldNumber}
          IF UPPER(FieldLabel) = UPPER(FieldString)
            ReplaceString = CLIP(WHAT(SELF.MailFileQueue.FileRecord, FieldNumber) & '')
            BREAK
          END
        END
        WM = SendMessage(SELF.RTFHwnd, EM_SETSEL, StartPos, EndPos)
        WM = SendMessage(SELF.RTFhwnd, EM_REPLACESEL, TRUE, ADDRESS(ReplaceString))
      END
    END
  END

  SELF.SetFocus
  RETURN(TRUE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Create a Queue of all available fonts
!|
LocRichEditClass.CreateFonts        PROCEDURE()

lpLogfont       LIKE(_LOGFONT)
DeviceDC        LONG
FontNo          LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  DeviceDC = GETDC(SELF.RTFhwnd)
  CLEAR(lpLogfont)
  lpLogfont.lfCharset = DEFAULT_CHARSET

  IF FontQueue &= NULL
    FontQueue &= NEW(_FONTQUEUE)
  END

  ASSERT(EnumFontFamiliesEx(DeviceDC, lpLogfont, ADDRESS(EnumFontFamExProc), 0, 0))

  ASSERT(ReleaseDC(SELF.RTFhwnd, DeviceDC))

  IF SELF.FontQueue &= NULL
    SELF.FontQueue &= NEW(_FONTQUEUE)
  END
  LOOP FontNo = 1 TO RECORDS(FontQueue)
    GET(FontQueue, FontNo)
    SELF.FontQueue :=: FontQueue
    ADD(SELF.FontQueue)
  END

  DISPOSE(FontQueue)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Call Back Procedure for CreateFonts
!|
EnumFontFamExProc                   PROCEDURE(_LOGFONT LogFont, _TEXTMETRIC TextMetric, INT FontType, LONG lParam)

  CODE

  FontQueue.FontName = LogFont.lfFaceName

  GET(FontQueue, FontQueue.FontName)
  IF ERRORCODE()
    FontQueue.FontType = BAND(FontType, TRUETYPE_FONTTYPE)
    ADD(FontQueue,FontQueue.FontName)
  END

  RETURN(TRUE)

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Create a Queue of all available font sizes
!|
LocRichEditClass.CreateFontSize     PROCEDURE()

FontNumber      LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF SELF.FontSizeQueue &= NULL
    SELF.FontSizeQueue &= NEW(_FONTSIZEQUEUE)
  END

  SELF.FontSizeQueue.FontSize = ' 8'; ADD(SELF.FontSizeQueue)
  SELF.FontSizeQueue.FontSize = ' 9'; ADD(SELF.FontSizeQueue)
  LOOP FontNumber = 10 TO 12
    SELF.FontSizeQueue.FontSize = FontNumber; ADD(SELF.FontSizeQueue)
  END
  LOOP FontNumber = 14 TO 28 BY 2
    SELF.FontSizeQueue.FontSize = FontNumber; ADD(SELF.FontSizeQueue)
  END
  SELF.FontSizeQueue.FontSize = '36'; ADD(SELF.FontSizeQueue)
  SELF.FontSizeQueue.FontSize = '48'; ADD(SELF.FontSizeQueue)
  SELF.FontSizeQueue.FontSize = '72'; ADD(SELF.FontSizeQueue)
! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Strip path and extension from filename and store the new name
!|
LocRichEditClass.StripName          PROCEDURE()

CurPos      LONG
OldPos      LONG
StartPos    LONG
StopPos     LONG

  CODE

  ASSERT(SELF.RTFhwnd)

  IF NOT SELF.FileName
    SELF.StripFileName = 'Database File'
    RETURN
  END

  OldPos = 0
  CurPos = 0
  LOOP
    OldPos = CurPos
    CurPos = INSTRING('\', SELF.FileName, 1, OldPos + 1)
  UNTIL CurPos = 0
  StartPos = OldPos

  OldPos = 0
  CurPos = 0
  LOOP
    OldPos = CurPos
    CurPos = INSTRING('.', SELF.FileName, 1, OldPos + 1)
  UNTIL CurPos = 0
  StopPos = OldPos
  IF StopPos = 0
    StopPos = LEN(SELF.FileName) + 1
  END

  SELF.StripFileName = SELF.FileName[StartPos + 1 : StopPos - 1]

! ---------------------------------------------------------------------------------------------------------------------------
!|
!|  Open toolbox dialog in new thread
!|
PopToolbox                          PROCEDURE(STRING ProcAddress, STRING ToolBoxType)

ProcToCall      &LocRichEditClass

  CODE

  ProcToCall &= ProcAddress + 0

  CASE UPPER(CLIP(LEFT(ToolBoxType)))
  OF 'MAILMERGE' 
    IF ProcToCall.Setup.PopupMailMerge = FALSE
      ProcToCall.Setup.PopupMailMerge = TRUE
      ProcToCall.MailMerge
    ELSE
      IF ProcToCall.Setup.PopupMailInsert = FALSE !bk
      ELSE                                        !bk
        POST(EVENT:CloseWindow,,ProcToCall.Setup.PopupMailInsert)  !bk
      END                                                          !bk
      POST(EVENT:CloseWindow,,ProcToCall.Setup.PopupMailMerge)
    END
  OF 'FINDTEXT'
    IF ProcToCall.Setup.PopupFindText = FALSE
      ProcToCall.Setup.PopupFindText = TRUE
      ProcToCall.FindText
    END
  OF 'FINDNEXTTEXT'
    IF ProcToCall.Setup.PopupFindText = FALSE
      ProcToCall.Setup.PopupFindText = TRUE
      ProcToCall.FindText(TRUE)
    END
  OF 'REPLACETEXT'
    IF ProcToCall.Setup.PopupReplaceText = FALSE
      ProcToCall.Setup.PopupReplaceText = TRUE
      ProcToCall.ReplaceText
    END
  OF 'DATETIME'
    IF ProcToCall.Setup.PopupDateTime = FALSE
      ProcToCall.Setup.PopupDateTime = TRUE
      ProcToCall.DateTime
    END
  of 'MAILINSERT'    !bk
    IF ProcToCall.Setup.PopupMailInsert = FALSE     !bk
      ProcToCall.Setup.PopupMailInsert = TRUE       !bk
      ProcToCall.MailInsert                         !bk
    ELSE                                            !bk
      POST(EVENT:CloseWindow,,ProcToCall.Setup.PopupMailInsert)  !bk
    END                                             !bk

  END

! ---------------------------------------------------------------------------------------------------------------------------
!|
!| Open new thread for toolbox
!|
LocRichEditClass.ShowToolbox        PROCEDURE(STRING ToolBoxType)

  CODE

  ASSERT(SELF.RTFhwnd)

  START(PopToolbox, 25000, ADDRESS(SELF), ToolBoxType)

! ---------------------------------------------------------------------------------------------------------------------------
